Package: Bioc.gff
Title: Read and write GFF and GTF files
Version: 1.3.0
Date: 2025-09-24
Authors@R: c(
    person("Michael", "Lawrence", role = "aut"),
    person("Hervé", "Pagès", role = "aut"),
    person("Marcel", "Ramos", role = "ctb"),
    person(
      "Bioconductor", "Package Maintainer", ,
      "maintainer@bioconductor.org", "cre"
    )
  )
Description: Parse GFF and GTF files using C++ classes. The package also
    provides utilities to read and write GFF3 files. The GFF (General Feature
    Format) format is a tab-delimited file format for describing genes and
    other features of DNA, RNA, and protein sequences. GFF files are often
    used to describe the features of genomes.
Depends: R (>= 4.5.0)
Imports: BiocBaseUtils, BiocGenerics, BiocIO, curl, GenomicRanges,
        IRanges, methods, Rsamtools, S4Vectors, Seqinfo, stats, utils,
        XVector
Suggests: BiocFileCache, BiocStyle, GenomicFeatures, GenomeInfoDbData,
        knitr, httr2, rmarkdown, rvest, tinytest, txdbmaker,
        TxDb.Hsapiens.UCSC.hg19.knownGene
VignetteBuilder: knitr
LinkingTo: S4Vectors, XVector, IRanges
License: Artistic-2.0
biocViews: Software, Infrastructure, DataImport
Encoding: UTF-8
Roxygen: list(markdown = TRUE)
RoxygenNote: 7.3.3
URL: https://github.com/Bioconductor/Bioc.gff
BugReports: https://github.com/Bioconductor/Bioc.gff/issues
Collate: 'Bioc.gff-package.R' 'GFF-coercion.R' 'readGFF.R'
        'GFFFile-class.R' 'index.R' 'metadataFromNCBI.R' 'utilities.R'
git_url: https://git.bioconductor.org/packages/Bioc.gff
git_branch: devel
git_last_commit: 8b9196c
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.24
Date/Publication: 2026-04-28
NeedsCompilation: yes
Packaged: 2026-04-28 21:30:03 UTC; biocbuild
Author: Michael Lawrence [aut],
  Hervé Pagès [aut],
  Marcel Ramos [ctb],
  Bioconductor Package Maintainer [cre]
Maintainer: Bioconductor Package Maintainer <maintainer@bioconductor.org>

# Bioc.gff

## Introduction

The *[Bioc.gff](https://bioconductor.org/packages/3.22/Bioc.gff)*
package provides support for the General Feature Format (GFF) file
format, which is widely used for representing genomic features and
annotations. This package allows users to read, write, and manipulate
GFF versions 1, 2 (GTF), and 3 in R, making it easier to work with
genomic data.

While the
*[rtracklayer](https://bioconductor.org/packages/3.22/rtracklayer)*
package offers robust GFF support, it is a large package with many
features beyond file import. `Bioc.gff` fills a specific niche in the
Bioconductor ecosystem by providing a lightweight, focused solution with
minimal dependencies. This modularity is beneficial for developers of
other packages who need to parse GFF files without inheriting the
extensive dependency footprint of `rtracklayer`. For the end user, it
offers a simple and direct interface for GFF manipulation.

Note that much of the code in the package is ported and adapted from the
*[rtracklayer](https://bioconductor.org/packages/3.22/rtracklayer)*
Bioconductor package. The intention is that the GFF functionality
residing in
*[rtracklayer](https://bioconductor.org/packages/3.22/rtracklayer)* will
be removed from that package in favor of using `Bioc.gff`, thereby
reducing its size and complexity.

# Installation

You can install the `Bioc.gff` package from Bioconductor using the
following:

``` r
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("Bioc.gff")
```

# Loading packages

``` r
library(Bioc.gff)
library(GenomicRanges)
```

# Usage

The `Bioc.gff` package provides functions to read and write GFF files,
as well as to manipulate GFF data structures. The following sections
provide some examples of how to use the package.

## Reading GFF Files

You can read GFF files using the `readGFF` function. This function
supports GFF versions 1, 2, and 3. The following example demonstrates
how to read a GFF file:

``` r
gff_file <- system.file("extdata", "genes.gff3", package = "Bioc.gff")
```

### Using the `import` function

The `import` function deduces that the input string is a GFF file type
and calls the appropriate method for reading the GFF file.

``` r
import(gff_file)
#> GRanges object with 31 ranges and 10 metadata columns:
#>        seqnames      ranges strand |      source     type     score     phase            ID        Name        geneName           Alias
#>           <Rle>   <IRanges>  <Rle> |    <factor> <factor> <numeric> <integer>   <character> <character>     <character> <CharacterList>
#>    [1]    chr10 92828-95504      - | rtracklayer     gene         5      <NA> GeneID:347688       TUBB8 tubulin, beta 8  FLJ40100,TUBB8
#>    [2]    chr10 92828-95178      - | rtracklayer     mRNA        NA      <NA>           873       TUBB8            <NA>                
#>    [3]    chr10 92828-95504      - | rtracklayer     mRNA        NA      <NA>           872       TUBB8            <NA>                
#>    [4]    chr10 92828-94054      - | rtracklayer     exon        NA      <NA>          <NA>        <NA>            <NA>                
#>    [5]    chr10 92997-94054      - | rtracklayer     CDS         NA      <NA>          <NA>        <NA>            <NA>                
#>    ...      ...         ...    ... .         ...      ...       ...       ...           ...         ...             ...             ...
#>   [27]    chr12 89675-89827      + | rtracklayer     CDS         NA      <NA>          <NA>        <NA>            <NA>                
#>   [28]    chr12 90587-90655      + | rtracklayer     exon        NA      <NA>          <NA>        <NA>            <NA>                
#>   [29]    chr12 90587-90655      + | rtracklayer     CDS         NA      <NA>          <NA>        <NA>            <NA>                
#>   [30]    chr12 90796-91263      + | rtracklayer     exon        NA      <NA>          <NA>        <NA>            <NA>                
#>   [31]    chr12 90796-91263      * | rtracklayer     CDS         NA      <NA>          <NA>        <NA>            <NA>                
#>             genome          Parent
#>        <character> <CharacterList>
#>    [1]        hg19                
#>    [2]        <NA>   GeneID:347688
#>    [3]        <NA>   GeneID:347688
#>    [4]        <NA>         872,873
#>    [5]        <NA>         872,873
#>    ...         ...             ...
#>   [27]        <NA>            4644
#>   [28]        <NA>            4644
#>   [29]        <NA>            4644
#>   [30]        <NA>            4644
#>   [31]        <NA>            4644
#>   -------
#>   seqinfo: 2 sequences from an unspecified genome; no seqlengths
```

Here the output object is a `GRanges` class, which contains genomic
coordinates and associated metadata. The `GRanges` object indicates the
ranges with the `seqnames`, `ranges`, and `strand`, columns. The
associated metadata is stored in the `mcols` slot, which (in this
example) includes attributes like `source`, `type`, `phase`, `ID`,
`Name`, `geneName`, `Alias` and `genome`.

#### Selectively importing ranges

You can also selectively import ranges from the GFF file using the
`which` argument. This allows you to filter the data based on specific
criteria, such as chromosome or strand. For example, to import only the
ranges on chromosome 1:

``` r
which <- GRanges("chr10:90000-93000")
import(gff_file, which = which, genome = "hg19")
#> 
#> Attaching package: 'rtracklayer'
#> The following objects are masked from 'package:Bioc.gff':
#> 
#>     asGFF, export.gff, export.gff1, export.gff2, export.gff3, GFF1File, GFF2File, GFF3File, GFFcolnames, GFFFile, GTFFile,
#>     GVFFile, import.gff, import.gff1, import.gff2, import.gff3, readGFF
#> GRanges object with 5 ranges and 10 metadata columns:
#>       seqnames      ranges strand |      source     type     score     phase            ID        Name        geneName           Alias
#>          <Rle>   <IRanges>  <Rle> |    <factor> <factor> <numeric> <integer>   <character> <character>     <character> <CharacterList>
#>   [1]    chr10 92828-95504      - | rtracklayer     gene         5      <NA> GeneID:347688       TUBB8 tubulin, beta 8  FLJ40100,TUBB8
#>   [2]    chr10 92828-95178      - | rtracklayer     mRNA        NA      <NA>           873       TUBB8            <NA>                
#>   [3]    chr10 92828-95504      - | rtracklayer     mRNA        NA      <NA>           872       TUBB8            <NA>                
#>   [4]    chr10 92828-94054      - | rtracklayer     exon        NA      <NA>          <NA>        <NA>            <NA>                
#>   [5]    chr10 92997-94054      - | rtracklayer     CDS         NA      <NA>          <NA>        <NA>            <NA>                
#>            genome          Parent
#>       <character> <CharacterList>
#>   [1]        hg19                
#>   [2]        <NA>   GeneID:347688
#>   [3]        <NA>   GeneID:347688
#>   [4]        <NA>         872,873
#>   [5]        <NA>         872,873
#>   -------
#>   seqinfo: 298 sequences (2 circular) from hg19 genome
```

Note that you can indicate the genome build using the `genome` argument,
which is useful for ensuring that the imported data is compatible with
other genomic data you may be working with.

### Using the `readGFF` function

As an alternative, you can use the `readGFF` function directly, which is
more explicit about the GFF version:

``` r
readGFF(gff_file, version = "3")
#> DataFrame with 31 rows and 14 columns
#>        seqid      source     type     start       end     score      strand     phase            ID        Name        geneName
#>     <factor>    <factor> <factor> <integer> <integer> <numeric> <character> <integer>   <character> <character>     <character>
#> 1      chr10 rtracklayer     gene     92828     95504         5           -        NA GeneID:347688       TUBB8 tubulin, beta 8
#> 2      chr10 rtracklayer     mRNA     92828     95178        NA           -        NA           873       TUBB8              NA
#> 3      chr10 rtracklayer     mRNA     92828     95504        NA           -        NA           872       TUBB8              NA
#> 4      chr10 rtracklayer     exon     92828     94054        NA           -        NA            NA          NA              NA
#> 5      chr10 rtracklayer     CDS      92997     94054        NA           -        NA            NA          NA              NA
#> ...      ...         ...      ...       ...       ...       ...         ...       ...           ...         ...             ...
#>               Alias      genome          Parent
#>     <CharacterList> <character> <CharacterList>
#> 1    FLJ40100,TUBB8        hg19                
#> 2                            NA   GeneID:347688
#> 3                            NA   GeneID:347688
#> 4                            NA         872,873
#> 5                            NA         872,873
#> ...             ...         ...             ...
#>  [ reached 'max' / getOption("max.print") -- omitted 5 rows ]
```

This function returns a `DataFrame` object, which contains the same
information as the `GRanges` object but in a tabular format. Note that
one can use the `makeGRangesFromDataFrame` function to convert the
`DataFrame` returned by `readGFF` into a `GRanges` object, which is
often more convenient for downstream analysis:

``` r
readGFF(gff_file, version = "3") |>
    makeGRangesFromDataFrame(
        keep.extra.columns = TRUE
    )
#> GRanges object with 31 ranges and 10 metadata columns:
#>        seqnames      ranges strand |      source     type     score     phase            ID        Name        geneName           Alias
#>           <Rle>   <IRanges>  <Rle> |    <factor> <factor> <numeric> <integer>   <character> <character>     <character> <CharacterList>
#>    [1]    chr10 92828-95504      - | rtracklayer     gene         5      <NA> GeneID:347688       TUBB8 tubulin, beta 8  FLJ40100,TUBB8
#>    [2]    chr10 92828-95178      - | rtracklayer     mRNA        NA      <NA>           873       TUBB8            <NA>                
#>    [3]    chr10 92828-95504      - | rtracklayer     mRNA        NA      <NA>           872       TUBB8            <NA>                
#>    [4]    chr10 92828-94054      - | rtracklayer     exon        NA      <NA>          <NA>        <NA>            <NA>                
#>    [5]    chr10 92997-94054      - | rtracklayer     CDS         NA      <NA>          <NA>        <NA>            <NA>                
#>    ...      ...         ...    ... .         ...      ...       ...       ...           ...         ...             ...             ...
#>   [27]    chr12 89675-89827      + | rtracklayer     CDS         NA      <NA>          <NA>        <NA>            <NA>                
#>   [28]    chr12 90587-90655      + | rtracklayer     exon        NA      <NA>          <NA>        <NA>            <NA>                
#>   [29]    chr12 90587-90655      + | rtracklayer     CDS         NA      <NA>          <NA>        <NA>            <NA>                
#>   [30]    chr12 90796-91263      + | rtracklayer     exon        NA      <NA>          <NA>        <NA>            <NA>                
#>   [31]    chr12 90796-91263      * | rtracklayer     CDS         NA      <NA>          <NA>        <NA>            <NA>                
#>             genome          Parent
#>        <character> <CharacterList>
#>    [1]        hg19                
#>    [2]        <NA>   GeneID:347688
#>    [3]        <NA>   GeneID:347688
#>    [4]        <NA>         872,873
#>    [5]        <NA>         872,873
#>    ...         ...             ...
#>   [27]        <NA>            4644
#>   [28]        <NA>            4644
#>   [29]        <NA>            4644
#>   [30]        <NA>            4644
#>   [31]        <NA>            4644
#>   -------
#>   seqinfo: 2 sequences from an unspecified genome; no seqlengths
```

### Reading remote GFF files

You can also read GFF files from remote URLs. The `import` function can
handle URLs directly, allowing you to read GFF files hosted on remote
servers. On the Bioconductor Build System (BBS), we use the
`BiocFileCache` package to cache remote files, which avoids downloading
the file every time the code gets run.

``` r
library(BiocFileCache)
bfc <- BiocFileCache::BiocFileCache()
url <- "https://www.mirbase.org/download/hsa.gff3"
bquery <- bfcquery(bfc, url, "rname", exact = TRUE)
if (!nrow(bquery))
    bfcadd(x = bfc, rname = url, rtype = "web", download = TRUE)
gff_remote <-
    bfcrpath(bfc, rnames = url, exact = TRUE, download = FALSE, rtype = "web")
import(gff_remote)
#> GRanges object with 4801 ranges and 8 metadata columns:
#>          seqnames            ranges strand |   source                     type     score     phase             ID           Alias
#>             <Rle>         <IRanges>  <Rle> | <factor>                 <factor> <numeric> <integer>    <character> <CharacterList>
#>      [1]     chr1       17369-17436      - |       NA miRNA_primary_transcript        NA      <NA>      MI0022705       MI0022705
#>      [2]     chr1       17409-17431      - |       NA miRNA                           NA      <NA>   MIMAT0027618    MIMAT0027618
#>      [3]     chr1       17369-17391      - |       NA miRNA                           NA      <NA>   MIMAT0027619    MIMAT0027619
#>      [4]     chr1       30366-30503      + |       NA miRNA_primary_transcript        NA      <NA>      MI0006363       MI0006363
#>      [5]     chr1       30438-30458      + |       NA miRNA                           NA      <NA>   MIMAT0005890    MIMAT0005890
#>      ...      ...               ...    ... .      ...                      ...       ...       ...            ...             ...
#>   [4797]     chrY   2609229-2609252      + |       NA miRNA                           NA      <NA> MIMAT0023714_1    MIMAT0023714
#>   [4798]     chrY   4606120-4606228      + |       NA miRNA_primary_transcript        NA      <NA>      MI0032313       MI0032313
#>   [4799]     chrY   4606140-4606158      + |       NA miRNA                           NA      <NA>   MIMAT0039763    MIMAT0039763
#>   [4800]     chrY 13479177-13479266      + |       NA miRNA_primary_transcript        NA      <NA>      MI0039722       MI0039722
#>   [4801]     chrY 13479189-13479214      + |       NA miRNA                           NA      <NA>   MIMAT0049014    MIMAT0049014
#>                     Name Derives_from
#>              <character>  <character>
#>      [1]  hsa-mir-6859-1         <NA>
#>      [2] hsa-miR-6859-5p    MI0022705
#>      [3] hsa-miR-6859-3p    MI0022705
#>      [4]  hsa-mir-1302-2         <NA>
#>      [5]    hsa-miR-1302    MI0006363
#>      ...             ...          ...
#>   [4797]    hsa-miR-6089    MI0023563
#>   [4798]    hsa-mir-9985         <NA>
#>   [4799]    hsa-miR-9985    MI0032313
#>   [4800]   hsa-mir-12120         <NA>
#>   [4801]   hsa-miR-12120    MI0039722
#>   -------
#>   seqinfo: 24 sequences from an unspecified genome; no seqlengths
```

Otherwise, you can read the remote GFF file directly using the `readGFF`
function:

``` r
import(url, version = "3")
```

## Conversion to GFF

While `TxDb` objects are highly efficient for querying transcript
annotations within R, it is often necessary to export this data to a
standard, portable format for use with external tools or for sharing
with collaborators. The GFF3 format is a widely accepted standard for
this purpose. Converting a `TxDb` or a derivative object (like a
`GRangesList` of exons) into a GFF3-compatible `GRanges` object allows
for easy export. This is particularly useful for visualizing annotations
in genome browsers like IGV or UCSC, or for input into downstream
analysis pipelines that expect GFF3 files.

``` r
library(GenomicFeatures)
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
txdb <- TxDb.Hsapiens.UCSC.hg19.knownGene
exonsBy(txdb, by = "tx") |>
    asGFF()
#> GRanges object with 825453 ranges and 7 metadata columns:
#>                  seqnames        ranges strand |        type          ID        Name   exon_id   exon_name exon_rank      Parent
#>                     <Rle>     <IRanges>  <Rle> | <character> <character> <character> <integer> <character> <integer> <character>
#>        [1]           chr1   11874-14409      + |        mRNA       mRNA1           1      <NA>        <NA>      <NA>        <NA>
#>        [2]           chr1   11874-14409      + |        mRNA       mRNA2           2      <NA>        <NA>      <NA>        <NA>
#>        [3]           chr1   11874-14409      + |        mRNA       mRNA3           3      <NA>        <NA>      <NA>        <NA>
#>        [4]           chr1   69091-70008      + |        mRNA       mRNA4           4      <NA>        <NA>      <NA>        <NA>
#>        [5]           chr1 321084-321115      + |        mRNA       mRNA5           5      <NA>        <NA>      <NA>        <NA>
#>        ...            ...           ...    ... .         ...         ...         ...       ...         ...       ...         ...
#>   [825449] chrUn_gl000241   22732-22846      - |        exon  exon742489        <NA>    289961        <NA>         6   mRNA82957
#>   [825450] chrUn_gl000241   20433-20481      - |        exon  exon742490        <NA>    289960        <NA>         7   mRNA82957
#>   [825451] chrUn_gl000243   11501-11530      + |        exon  exon742491        <NA>    289967        <NA>         1   mRNA82958
#>   [825452] chrUn_gl000243   13608-13637      + |        exon  exon742492        <NA>    289968        <NA>         1   mRNA82959
#>   [825453] chrUn_gl000247     5787-5816      - |        exon  exon742493        <NA>    289969        <NA>         1   mRNA82960
#>   -------
#>   seqinfo: 93 sequences (1 circular) from hg19 genome
```

## GFF to TxDb

You can convert a `GFF` object to a `TxDb` object using the
`makeTxDbFromGFF` in the
*[txdbmaker](https://bioconductor.org/packages/3.22/txdbmaker)* package.
This is useful for creating a transcript database from GFF annotations,
which can then be used for various genomic analyses.

``` r
library(txdbmaker)
txdb <- makeTxDbFromGFF(
    file = gff_remote,
    format = "gff3",
    dataSource = "https://www.mirbase.org/download/hsa.gff3",
    organism = "Homo sapiens",
    taxonomyId = 9606
)
#> Import genomic features from the file as a GRanges object ... OK
#> Prepare the 'metadata' data frame ... OK
#> Make the TxDb object ...
#> Warning in .extract_transcripts_from_GRanges(tx_IDX, gr, mcols0$type, mcols0$ID, : the transcript names ("tx_name" column in the TxDb
#> object) imported from the "Name" attribute are not unique
#> Warning in .makeTxDb_normarg_chrominfo(chrominfo): genome version information is not available for this TxDb object
#> OK
genome <- grepv("genome-build-id", readLines(gff_remote)) |>
    strsplit("# genome-build-id:\\s+") |>
    unlist() |>
    tail(1L)
genome(txdb) <- genome
txdb
#> TxDb object:
#> # Db type: TxDb
#> # Supporting package: GenomicFeatures
#> # Data source: https://www.mirbase.org/download/hsa.gff3
#> # Organism: Homo sapiens
#> # Taxonomy ID: 9606
#> # Genome: NA
#> # Nb of transcripts: 4801
#> # Db created by: txdbmaker package from Bioconductor
#> # Creation time: 2025-09-11 17:01:07 -0400 (Thu, 11 Sep 2025)
#> # txdbmaker version at creation time: 1.5.6
#> # RSQLite version at creation time: 2.4.3
#> # DBSCHEMAVERSION: 1.2
```

# SessionInfo

``` r
sessionInfo()
#> R version 4.5.1 Patched (2025-06-14 r88325)
#> Platform: x86_64-pc-linux-gnu
#> Running under: Ubuntu 24.04.3 LTS
#> 
#> Matrix products: default
#> BLAS/LAPACK: /usr/lib/x86_64-linux-gnu/openblas-pthread/libopenblasp-r0.3.26.so;  LAPACK version 3.12.0
#> 
#> locale:
#>  [1] LC_CTYPE=en_US.UTF-8       LC_NUMERIC=C               LC_TIME=en_US.UTF-8        LC_COLLATE=en_US.UTF-8     LC_MONETARY=en_US.UTF-8   
#>  [6] LC_MESSAGES=en_US.UTF-8    LC_PAPER=en_US.UTF-8       LC_NAME=C                  LC_ADDRESS=C               LC_TELEPHONE=C            
#> [11] LC_MEASUREMENT=en_US.UTF-8 LC_IDENTIFICATION=C       
#> 
#> time zone: America/New_York
#> tzcode source: system (glibc)
#> 
#> attached base packages:
#> [1] stats4    stats     graphics  grDevices utils     datasets  methods   base     
#> 
#> other attached packages:
#>  [1] BSgenome.Hsapiens.UCSC.hg19_1.4.3       BSgenome_1.77.1                         rtracklayer_1.69.1                     
#>  [4] txdbmaker_1.5.6                         TxDb.Hsapiens.UCSC.hg19.knownGene_3.2.2 GenomicFeatures_1.61.6                 
#>  [7] AnnotationDbi_1.71.1                    Biobase_2.69.0                          BiocStyle_2.37.1                       
#> [10] BiocFileCache_2.99.6                    dbplyr_2.5.1                            Rsamtools_2.25.3                       
#> [13] Biostrings_2.77.2                       XVector_0.49.0                          BiocIO_1.19.0                          
#> [16] GenomicRanges_1.61.2                    Seqinfo_0.99.2                          IRanges_2.43.0                         
#> [19] S4Vectors_0.47.0                        BiocGenerics_0.55.1                     generics_0.1.4                         
#> [22] Bioc.gff_0.99.13                        colorout_1.3-2                         
#> 
#> loaded via a namespace (and not attached):
#>  [1] tidyselect_1.2.1            dplyr_1.1.4                 blob_1.2.4                  filelock_1.0.3             
#>  [5] bitops_1.0-9                fastmap_1.2.0               lazyeval_0.2.2              RCurl_1.98-1.17            
#>  [9] GenomicAlignments_1.45.2    promises_1.3.3              rex_1.2.1                   XML_3.99-0.19              
#> [13] digest_0.6.37               lifecycle_1.0.4             processx_3.8.6              KEGGREST_1.49.1            
#> [17] RSQLite_2.4.3               magrittr_2.0.3              compiler_4.5.1              progress_1.2.3             
#> [21] rlang_1.1.6                 tools_4.5.1                 yaml_2.3.10                 knitr_1.50                 
#> [25] prettyunits_1.2.0           S4Arrays_1.9.1              bit_4.6.0                   curl_7.0.0                 
#> [29] DelayedArray_0.35.2         xml2_1.4.0                  abind_1.4-8                 BiocParallel_1.43.4        
#> [33] rsconnect_1.5.1             websocket_1.4.4             covr_3.6.4                  withr_3.0.2                
#> [37] purrr_1.1.0                 grid_4.5.1                  biomaRt_2.65.7              SummarizedExperiment_1.39.1
#> [41] cli_3.6.5                   rmarkdown_2.29              crayon_1.5.3                tinytest_1.4.1             
#> [45] rstudioapi_0.17.1           httr_1.4.7                  rjson_0.2.23                BiocBaseUtils_1.11.2       
#> [49] DBI_1.2.3                   cachem_1.1.0                chromote_0.5.1              stringr_1.5.2              
#> [53] rvest_1.0.5                 parallel_4.5.1              selectr_0.4-2               BiocManager_1.30.26        
#> [57] restfulr_0.0.16             matrixStats_1.5.0           vctrs_0.6.5                 Matrix_1.7-4               
#> [61] jsonlite_2.0.0              hms_1.1.3                   bit64_4.6.0-1               glue_1.8.0                 
#> [65] codetools_0.2-20            ps_1.9.1                    stringi_1.8.7               later_1.4.4                
#> [69] GenomeInfoDb_1.45.10        UCSC.utils_1.5.0            tibble_3.3.0                pillar_1.11.0              
#> [73] rappdirs_0.3.3              htmltools_0.5.8.1           GenomeInfoDbData_1.2.14     R6_2.6.1                   
#> [77] httr2_1.2.1                 lattice_0.22-7              evaluate_1.0.5              png_0.1-8                  
#> [81] memoise_2.0.1               Rcpp_1.1.0                  SparseArray_1.9.1           xfun_0.53                  
#> [85] MatrixGenerics_1.21.0       pkgconfig_2.0.3
```

#' @include readGFF.R

# GFF (General Feature Format) support (all three versions, plus G --------

#' @name GFFFile-class
#'
#' @aliases class:GFFFile class:GFF1File class:GFF2File class:GFF3File
#' class:GVFFile class:GTFFile GFFFile-class GFF1File-class GFF2File-class
#' GFF3File-class GVFFile-class GTFFile-class GFFFile GFF1File GFF2File
#' GFF3File GVFFile GTFFile import,GFFFile,ANY,ANY-method import.gff
#' import.gff1 import.gff2 import.gff3 import.gff,ANY-method
#' import.gff1,ANY-method import.gff2,ANY-method import.gff3,ANY-method
#' export,ANY,GFFFile,ANY-method export,GenomicRanges,GFFFile,ANY-method
#' export,GenomicRangesList,GFFFile,ANY-method
#' export,GRangesList,GFFFile,ANY-method export,GRangesList,GTFFile,ANY-method
#' export.gff export.gff,ANY-method export.gff1 export.gff1,ANY-method
#' export.gff2 export.gff2,ANY-method export.gff3 export.gff3,ANY-method
#' genome,GFFFile-method
#'
#' @docType class
#'
#' @title GFFFile objects
#'
#' @description These functions support the import and export of the GFF format,
#'   of which there are three versions and several flavors.
#'
#' @details The Generic Feature Format (GFF) format is a tab-separated table of
#' intervals. There are three different versions of GFF, and they all have the
#' same number of columns. In GFF1, the last column is a grouping factor,
#' whereas in the later versions the last column holds application-specific
#' attributes, with some conventions defined for those commonly used. This
#' attribute support facilitates specifying extensions to the format. These
#' include GTF (Gene Transfer Format, an extension of GFF2) and GVF (Genome
#' Variation Format, an extension of GFF3).  The `Bioc.gff` package recognizes
#' the "gtf" and "gvf" extensions and parses the extra attributes
#' into columns of the result; however, it does not perform any
#' extension-specific processing. Both GFF1 and GFF2 have been proclaimed
#' obsolete; however, the UCSC Genome Browser only supports GFF1 (and GTF), and
#' GFF2 is still in broad use.
#'
#' GFF is distinguished from the simpler BED format by its flexible attribute
#' support and its hierarchical structure, as specified by the `group`
#' column in GFF1 (only one level of grouping) and the `Parent` attribute
#' in GFF3. GFF2 does not specify a convention for representing hierarchies,
#' although its GTF extension provides this for gene structures. The
#' combination of support for hierarchical data and arbitrary descriptive
#' attributes makes GFF(3) the preferred format for representing gene models.
#'
#' Although GFF features a `score` column, large quantitative data belong
#' in a format like `BigWig` and alignments from
#' high-throughput experiments belong in \link[Rsamtools:BamFile]{BAM}. For
#' variants, the VCF format (supported by the VariantAnnotation package) seems
#' to be more widely adopted than the GVF extension.
#'
#' A note on the UCSC track line metaformat: track lines are a means for
#' passing hints to visualization tools like the UCSC Genome Browser and the
#' Integrated Genome Browser (IGB), and they allow multiple tracks to be
#' concatenated in the same file. Since GFF is not a UCSC format, it is not
#' common to annotate GFF data with track lines, but `Bioc.gff` still
#' supports it. To export or import GFF data in the track line format, call
#' `export.ucsc` or `import.ucsc`.
#'
#' The following is the mapping of GFF elements to a `GRanges` object.  NA
#' values are allowed only where indicated.  These appear as a "." in
#' the file. GFF requires that all columns are included, so `export`
#' generates defaults for missing columns.
#'
#' \describe{
#' \item{seqid, start, end}{the `ranges` component.}
#' \item{source}{character vector in the `source` column; defaults to
#'   "Bioc.gff" on export.}
#' \item{type}{character vector in the `type` column; defaults to
#'   "sequence_feature" in the output, i.e., SO:0000110.}
#' \item{score}{numeric vector (NA's allowed) in the `score` column,
#'   accessible via the `score` accessor; defaults to `NA` upon export.}
#' \item{strand}{strand factor (NA's allowed) in the `strand` column,
#'   accessible via the `strand` accessor; defaults to `NA` upon export.}
#' \item{phase}{integer vector, either 0, 1 or 2 (NA's allowed); defaults to
#'   `NA` upon export.}
#' \item{group}{a factor (GFF1 only); defaults to the `seqid` (e.g.,
#'   chromosome) on export.}
#' }
#'
#' In GFF versions 2 and 3, attributes map to arbitrary columns in the result.
#' In GFF3, some attributes (`Parent`, `Alias`, `Note`, `DBxref` and
#' `Ontology_term`) can have multiple, comma-separated values; these columns are
#' thus always `CharacterList` objects.
#'
#' @param con A path, URL, connection or `GFFFile` object. For the functions
#'   ending in `.gff`, `.gff1`, etc, the file format is indicated by the
#'   function name. For the base `export` and `import` functions, the format
#'   must be indicated another way. If `con` is a path, URL or connection,
#'   either the file extension or the `format` argument needs to be one of
#'   "gff", "gff1" "gff2", "gff3", "gvf", or "gtf". Compressed files ("gz",
#'   "bz2" and "xz") are handled transparently.
#'
#' @param object The object to export, should be a `GRanges` or something
#'   coercible to a `GRanges`. If the object has a method for `asGFF`, it is
#'   called prior to coercion. This makes it possible to export a `GRangesList`
#'   or `TxDb` in a way that preserves the hierarchical structure. For exporting
#'   multiple tracks, in the UCSC track line metaformat, pass a
#'   `GenomicRangesList`, or something coercible to one.
#'
#' @param format If not missing, should be one of "gff", "gff1" "gff2", "gff3",
#'   "gvf", or "gtf".
#'
#' @param version If the format is given as "gff", i.e., it does not specify a
#'   version, then this should indicate the GFF version as one of \dQuote{} (for
#'   import only, from the `gff-version` directive in the file or "1" if none),
#'   "1", "2" or "3".
#'
#' @param text If `con` is missing, a character vector to use as the input.
#'
#' @param genome The identifier of a genome, or a `Seqinfo`, or `NA` if unknown.
#'   Typically, this is a UCSC identifier like "hg19". An attempt will be made
#'   to derive the `Seqinfo` on the return value using either an installed
#'   BSgenome package or UCSC, if network access is available.
#'
#' @param colnames A character vector naming the columns to parse. These should
#'   name either fixed fields, like `source` or `type`, or, for GFF2 and GFF3,
#'   any attribute.
#'
#' @param which A `GRanges` or other range-based object supported by
#'   \code{\link[IRanges]{findOverlaps}}. Only the intervals in the file
#'   overlapping the given ranges are returned. This is much more efficient when
#'   the file is indexed with the tabix utility.
#'
#' @param feature.type `NULL` (the default) or a character vector of valid
#'   feature types. If not `NULL`, then only the features of the specified
#'   type(s) are imported.
#'
#' @param sequenceRegionsAsSeqinfo If `TRUE`, attempt to infer the `Seqinfo`
#'   (`seqlevels` and `seqlengths`) from the \dQuote{##sequence-region}
#'   directives as specified by GFF3.
#'
#' @param source The value for the source column in GFF. This is typically the
#'   name of the package or algorithm that generated the feature.
#'
#' @param index If `TRUE`, automatically compress and index the output file with
#'   bgzf and tabix. Note that tabix indexing will sort the data by chromosome
#'   and start. Tabix supports a single track in a file.
#'
#' @param append If `TRUE`, and `con` points to a file path, the data is
#'   appended to the file. Obviously, if `con` is a connection, the data is
#'   always appended.
#'
#' @param ... Arguments to pass down to methods to other methods. For import,
#'   the flow eventually reaches the `GFFFile` method on `import`. When
#'   `trackLine` is `TRUE` or the target format is BED15, the arguments are
#'   passed through `export.ucsc`, so track line parameters are supported.
#'
#' @param x A `GFFFile` object.
#'
#' @return A `GRanges` with the metadata columns described in the details.
#'
#' @section GFFFile objects: The `GFFFile` class extends
#'   \code{\link[BiocIO:BiocFile-class]{BiocFile}} and is a formal
#'   representation of a resource in the GFF format.  To cast a path, URL or
#'   connection to a `GFFFile`, pass it to the `GFFFile` constructor. The
#'   `GFF1File`, `GFF2File`, `GFF3File`, `GVFFile` and `GTFFile` classes all
#'   extend `GFFFile` and indicate a particular version of the format.
#'
#' @author Michael Lawrence
#'
#' @references
#' * GFF1, GFF2: <http://www.sanger.ac.uk/resources/software/gff/spec.html>
#' * GFF3: <http://www.sequenceontology.org/gff3.shtml>
#' * GVF: <http://www.sequenceontology.org/resources/gvf.html>
#' * GTF: <http://mblab.wustl.edu/GTF22.html>
#'
#' @keywords methods classes
#' @examples
#'
#' test_gff3 <- system.file(
#'     "extdata", "genes.gff3", package = "Bioc.gff", mustWork = TRUE
#' )
#'
#' ## basic import
#' test <- import(test_gff3)
#' test
#'
#' ## import.gff functions
#' import.gff(test_gff3)
#' import.gff3(test_gff3)
#'
#' ## GFFFile derivatives
#' test_gff_file <- GFF3File(test_gff3)
#' import(test_gff_file)
#' test_gff_file <- GFFFile(test_gff3)
#' import(test_gff_file)
#' test_gff_file <- GFFFile(test_gff3, version = "3")
#' import(test_gff_file)
#'
#' ## from connection
#' test_gff_con <- file(test_gff3)
#' test <- import(test_gff_con, format = "gff")
#'
#' ## various arguments
#' import(test_gff3, genome = "hg19")
#' import(test_gff3, colnames = character())
#' import(test_gff3, colnames = c("type", "geneName"))
#'
#' ## 'which'
#' library(GenomicRanges)
#' which <- GRanges("chr10:90000-93000")
#' import(test_gff3, which = which)
#'
#' ## 'append'
#' test_gff3_out <- file.path(tempdir(), "genes.gff3")
#'
#' export(test[seqnames(test) == "chr10"], test_gff3_out)
#' export(test[seqnames(test) == "chr12"], test_gff3_out, append = TRUE)
#' import(test_gff3_out)
#'
#' ## 'index'
#' export(test, test_gff3_out, index = TRUE)
#' test_bed_gz <- paste(test_gff3_out, ".bgz", sep = "")
#' import(test_bed_gz, which = which)
#'
#' ## cleanup
#' file.remove(
#'     test_gff3_out, test_bed_gz, paste(test_bed_gz, "tbi", sep = ".")
#' )
#'
NULL

# Classes -----------------------------------------------------------------

#' @rdname GFFFile-class
#'
#' @importClassesFrom BiocIO BiocFile
#' @exportClass GFFFile
setClass("GFFFile", contains = "BiocFile")

#' @rdname GFFFile-class
#'
#' @importFrom methods new
#' @param resource `character(1)` or `connection` A low-level resource typically
#'   a path, URL, or connection.
#'
#' @export
GFFFile <- function(resource, version = c("", "1", "2", "3")) {
    version <- match.arg(version)
    new(gffFileClass(version), resource = resource)
}

#' @exportClass GFF1File
setClass("GFF1File", contains = "GFFFile")

#' @export
GFF1File <- function(resource) {
    GFFFile(resource, "1")
}

#' @exportClass GFF2File
setClass("GFF2File", contains = "GFFFile")

#' @export
GFF2File <- function(resource) {
    GFFFile(resource, "2")
}

#' @exportClass GFF3File
setClass("GFF3File", contains = "GFFFile")

#' @export
GFF3File <- function(resource) {
    GFFFile(resource, "3")
}

#' @exportClass GTFFile
setClass("GTFFile", contains = "GFF2File")

#' @export
GTFFile <- function(resource) {
    new("GTFFile", GFF2File(resource))
}

#' @exportClass GVFFile
setClass("GVFFile", contains = "GFF3File")

#' @export
GVFFile <- function(resource) {
    new("GVFFile", GFF3File(resource))
}

# Export ------------------------------------------------------------------

#' @describeIn GFFFile-class
#'
#' @export
setGeneric(
    "export.gff",
    function(object, con, ...) standardGeneric("export.gff")
)

#' @describeIn GFFFile-class
#'
#' @exportMethod export.gff
setMethod("export.gff", "ANY", function(object, con, ...) {
    export(object, con, ...)
})

#' @describeIn GFFFile-class
#'
#' @importFrom BiocIO export
#' @importFrom methods is as hasMethod
#' @exportMethod export
setMethod("export", c("ANY", "GFFFile"), function(object, con, format, ...) {
    if (hasMethod("asGFF", class(object))) object <- asGFF(object)
    res <- try(as(object, "GRanges"), silent = TRUE)
    if (is(res, "try-error")) {
        res <- try(as(object, "GenomicRangedDataList"), silent = TRUE)
        if (is(res, "try-error"))
            stop("cannot export object of class '", class(object), "'")
    }
    object <- res
    if (!missing(format)) checkArgFormat(con, format)
    export(object, con, ...)
})

#' @describeIn GFFFile-class
#'
#' @importClassesFrom GenomicRanges CompressedGRangesList GRangesList
#'   GenomicRanges
#' @importFrom methods callGeneric
#'
#' @exportMethod export
setMethod(
    "export",
    c("CompressedGRangesList", "GFFFile"),
    function(object, con, format, ...) {
        object <- asGFF(object)
        callGeneric()
    }
)

#' @exportMethod export
setMethod(
    "export",
    c("GRangesList", "GTFFile"),
    function(object, con, format, ...) {
        stop("export of GRangesList to GTF is not yet supported")
        ## there is a start on asGTF() later in this file
        ## object <- asGTF(object)
        ## callGeneric()
    }
)

#' @describeIn GFFFile-class
#'
#' @importFrom BiocIO resource
#' @importFrom Seqinfo genome seqnames
#' @importFrom BiocGenerics start
#' @importFrom utils packageVersion relist write.table
#' @importFrom S4Vectors wmsg
#'
#' @exportMethod export
setMethod(
    "export",
    c("GenomicRanges", "GFFFile"),
    function(
        object,
        con,
        format,
        version = c("1", "2", "3"),
        source = "Bioc.gff",
        append = FALSE,
        index = FALSE
    ) {
        if (!missing(format)) checkArgFormat(con, format)
        if (!missing(version) || !length(gffFileVersion(con)))
            con <- asGFFVersion(con, match.arg(version))
        version <- gffFileVersion(con)

        file <- con
        con <- resource(con)

        if (!append) {
            cat("", file = con) # clear any existing file
            gffComment(con, "gff-version", version)
            sourceVersion <- try(packageVersion(source), TRUE)
            if (!inherits(sourceVersion, "try-error"))
                gffComment(con, "source-version", source, sourceVersion)
            gffComment(con, "date", base::format(Sys.time(), "%Y-%m-%d"))
            genome <- singleGenome(genome(object))
            if (!is.na(genome))
                gffComment(con, "genome-build", paste(".", genome, sep = "\t"))
        }

        if (index) object <- .sortBySeqnameAndStart(object)

        seqname <- seqnames(object)
        if (is.null(mcols(object)$ID)) mcols(object)$ID <- names(object)
        if (version == "3")
            seqname <- urlEncode(seqname, "a-zA-Z0-9.:^*$@!+_?|-")
        if (!is.null(mcols(object)$source) && missing(source))
            source <- mcols(object)$source else
            source <- rep(source, length(object))
        if (version == "3") source <- urlEncode(source, "\t\n\r;=%&,", FALSE)
        feature <- mcols(object)$type
        if (is.null(feature)) feature <- rep("sequence_feature", length(object))
        score <- score(object)
        if (is.null(score)) {
            score <- rep(NA_real_, length(object))
        } else {
            if (!("score" %in% colnames(mcols(object))))
                ## avoid outputting as attribute
                colnames(mcols(object))[1] <- "score"
        }
        strand <- strand(object)
        if (is.null(strand))
            strand <- rep(strand(NA_character_), length(object))
        strand[strand == "*"] <- NA_integer_
        frame <- mcols(object)$phase
        if (is.null(frame)) {
            frame <- rep(NA_integer_, length(object))
            if ("CDS" %in% feature)
                warning(wmsg(
                    "The phase information is missing. ",
                    "The written file will contain CDS with ",
                    "no phase information."
                ))
        } else {
            if (anyNA(frame[feature %in% "CDS"]))
                warning(wmsg(
                    "The phase information is missing for some CDS. ",
                    "The written file will contain some CDS with ",
                    "no phase information."
                ))
        }

        table <- data.frame(
            seqname,
            source,
            feature,
            start(object),
            end(object),
            score,
            strand,
            frame
        )

        attrs <- NULL
        if (version == "1") {
            attrs <- mcols(object)$group
            if (is.null(attrs)) attrs <- as.vector(seqname)
        } else {
            builtin <- c("type", "score", "phase", "source")
            custom <- setdiff(colnames(mcols(object)), builtin)
            if (length(custom)) {
                if (version == "3") tvsep <- "=" else tvsep <- " "
                attrs <- mcols(object)
                names(custom) <- custom
                lattrs <- lapply(custom, function(name) {
                    x <- attrs[[name]]
                    x_flat <- if (is(x, "List"))
                        unlist(x, use.names = FALSE) else x
                    x_char <- as.character(x_flat)
                    x_char <- sub(
                        " *$",
                        "",
                        sub("^ *", "", as.character(x_char))
                    )
                    if (version == "3")
                        x_char <- urlEncode(x_char, "%\t\n\r;=&,", FALSE)
                    if (is(x, "List")) {
                        x_char[is.na(x_char)] <- "."
                        x_char <- pasteCollapse(IRanges::relist(x_char, x))
                        x_char[elementNROWS(x) == 0] <- NA
                    }
                    ## FIXME: add option so these become "." instead of removing
                    x_char[is.na(x_char)] <- "\r"
                    if (!is.numeric(x_flat) && version != "3")
                        x_char <- paste0("\"", x_char, "\"")
                    paste(name, x_char, sep = tvsep)
                })
                attrs <- as.data.frame(lattrs)
                if (version == "3") sep <- ";" else sep <- "; "
                attrs <- do.call(paste, c(attrs, sep = sep))
                attrs <- gsub("[^;]*?\r\"?(;|$)", "", attrs)
                attrs[nchar(attrs) == 0] <- NA
            }
        }

        scipen <- getOption("scipen")
        options(scipen = 100) # prevent use of scientific notation
        on.exit(options(scipen = scipen))

        if (!is.null(attrs)) {
            # write out the rows with attributes first
            write.table(
                cbind(table, attrs)[!is.na(attrs), ],
                con,
                sep = "\t",
                na = ".",
                quote = FALSE,
                col.names = FALSE,
                row.names = FALSE,
                append = TRUE
            )
            table <- table[is.na(attrs), ]
        }

        write.table(
            table,
            con,
            sep = "\t",
            na = ".",
            quote = FALSE,
            col.names = FALSE,
            row.names = FALSE,
            append = TRUE
        )
        if (index) indexTrack(file)
        invisible(NULL)
    }
)

setClass("UCSCFile", contains = "BiocFile")

UCSCFile <- function(resource) {
    new("UCSCFile", resource = resource)
}

#' @importFrom BiocIO fileFormat
.export_SimpleGRangesList_BiocFile <- function(object, con, format, ...) {
    export(object, UCSCFile(resource(con)), subformat = fileFormat(con), ...)
}

#' @describeIn GFFFile-class
#'
#' @exportMethod export
setMethod(
    "export",
    c("SimpleGRangesList", "GFFFile"),
    .export_SimpleGRangesList_BiocFile
)

#' @describeIn GFFFile-class
#'
#' @export
setGeneric(
    "export.gff1",
    function(object, con, ...) standardGeneric("export.gff1")
)

#' @describeIn GFFFile-class
#'
#' @exportMethod export.gff1
setMethod(
    "export.gff1",
    "ANY",
    function(object, con, ...) export(object, con, "gff1", ...)
)

#' @describeIn GFFFile-class
#'
#' @export
setGeneric(
    "export.gff2",
    function(object, con, ...) standardGeneric("export.gff2")
)

#' @describeIn GFFFile-class
#'
#' @exportMethod export.gff2
setMethod(
    "export.gff2",
    "ANY",
    function(object, con, ...) export(object, con, "gff2", ...)
)

#' @describeIn GFFFile-class
#'
#' @export
setGeneric(
    "export.gff3",
    function(object, con, ...) standardGeneric("export.gff3")
)

#' @describeIn GFFFile-class
#'
#' @exportMethod export.gff3
setMethod(
    "export.gff3",
    "ANY",
    function(object, con, ...) export(object, con, "gff3", ...)
)

# Import ------------------------------------------------------------------

#' @export
setGeneric("import.gff", function(con, ...) standardGeneric("import.gff"))

#' @exportMethod import.gff
setMethod("import.gff", "ANY", function(con, ...) {
    import(con, "gff", ...)
})

connection <- BiocIO:::connection
manager <- BiocIO:::manager
release <- BiocIO:::release

#' @describeIn GFFFile-class
#'
#' @importFrom BiocIO import
#' @importFrom utils download.file
#' @importFrom IRanges subsetByOverlaps
#' @importFrom S4Vectors isTRUEorFALSE
#'
#' @exportMethod import
setMethod(
    "import",
    "GFFFile",
    function(
        con,
        format,
        text,
        version = c("", "1", "2", "3"),
        genome = NA,
        colnames = NULL,
        which = NULL,
        feature.type = NULL,
        sequenceRegionsAsSeqinfo = FALSE
    ) {
        if (!missing(format)) checkArgFormat(con, format)
        if (!missing(version)) con <- asGFFVersion(con, match.arg(version))
        stopifnot(isTRUEorFALSE(sequenceRegionsAsSeqinfo))

        ## download the file first if it's remote
        if (is.character(resource(con))) {
            uri <- BiocIO:::.parseURI(resource(con))
            if (uri$scheme %in% c("ftp", "http")) {
                destfile <- tempfile()
                download.file(resource(con), destfile)
                con@resource <- destfile
            }
        }

        m <- manager()
        sniff_con <- connection(m, con, "r")
        on.exit(release(m, sniff_con))
        sniffed <- .sniffGFFVersion(sniff_con)
        version <- gffFileVersion(con)
        if (!length(version)) {
            if (is.null(sniffed)) sniffed <- "1"
            con <- asGFFVersion(con, sniffed)
        }

        if (
            length(version) && !is.null(sniffed) && !identical(sniffed, version)
        )
            warning(
                "gff-version directive indicates version is ",
                sniffed,
                ", not ",
                version
            )

        if (is(genome, "Seqinfo") && length(genome) == 0L) {
            genome <- NA_character_
        }

        if (is.na(genome)) {
            genome <- genome(con)
            if (is.null(genome)) genome <- NA
        }

        ### FIXME: a queryForLines() function would be more efficient

        ## Temporarily disable use of Tabix Index.
        ## TODO: Restore use of Tabix Index!
        #con <- queryForResource(m, con, which)
        resource <- queryForResource(m, con)
        on.exit(release(m, resource), add = TRUE)
        ans <- readGFFAsGRanges(
            resource,
            version = version,
            colnames = colnames,
            filter = list(type = feature.type),
            genome = genome,
            sequenceRegionsAsSeqinfo = sequenceRegionsAsSeqinfo,
            speciesAsMetadata = TRUE
        )
        if (!attr(resource, "usedWhich") && !is.null(which))
            ans <- subsetByOverlaps(ans, which)
        ans
    }
)

#' @describeIn GFFFile-class
#'
#' @export
setGeneric("import.gff1", function(con, ...) standardGeneric("import.gff1"))

#' @describeIn GFFFile-class
#'
#' @exportMethod import.gff1
setMethod("import.gff1", "ANY", function(con, ...) import(con, "gff1", ...))

#' @describeIn GFFFile-class
#'
#' @export
setGeneric("import.gff2", function(con, ...) standardGeneric("import.gff2"))

#' @describeIn GFFFile-class
#'
#' @exportMethod import.gff2
setMethod("import.gff2", "ANY", function(con, ...) import(con, "gff2", ...))

#' @describeIn GFFFile-class
#'
#' @export
setGeneric("import.gff3", function(con, ...) standardGeneric("import.gff3"))

#' @describeIn GFFFile-class
#'
#' @exportMethod import.gff3
setMethod("import.gff3", "ANY", function(con, ...) import(con, "gff3", ...))

library(Bioc.gff)
library(BiocIO)
library(Rsamtools)
library(GenomicRanges)

## Setup: create a compressed and indexed GFF file
gff_file <- system.file("extdata", "genes.gff3", package = "Bioc.gff")
gff_data <- import(gff_file)
sorted_gff <- sort(gff_data)

temp_dir <- tempfile()
dir.create(temp_dir)

sorted_gff_path <- file.path(temp_dir, "sorted.gff3")
export(sorted_gff, sorted_gff_path)

bgzipped_path <- bgzip(sorted_gff_path, overwrite = TRUE)
indexed_path <- indexTabix(bgzipped_path, "gff")

tbi_file <- TabixFile(bgzipped_path)
gff_file_obj <- GFFFile(bgzipped_path)
query_range <- GRanges("chr12", IRanges(11200000, 11200200))
mgr <- BiocIO:::manager()

## Test BiocFile method, no index present
unindexed_gff_obj <- GFFFile(gff_file)
res_no_index <- Bioc.gff:::queryForResource(mgr, unindexed_gff_obj)
expect_false(attr(res_no_index, "usedWhich"))
expect_equal(res_no_index[[1L]], gff_file)

res_no_index_which <- Bioc.gff:::queryForResource(
    mgr, unindexed_gff_obj, which = query_range
)
expect_false(attr(res_no_index_which, "usedWhich"))
expect_equal(res_no_index_which[[1L]], gff_file)

## Cleanup
BiocIO:::release(mgr, res_no_index)
unlink(temp_dir, recursive = TRUE)

#' @name readGFF
#'
#' @title Reads a file in GFF format
#'
#' @description Reads a file in GFF format and creates a data frame or
#'   [S4Vectors::DataFrame()] object from it. This is a lower-level function
#'   that should not be called by the end user. Users are recommended to use
#'   the `import()` function on the `GFFFile` or file path.
#'
#' @aliases readGFF GFFcolnames
#'
#' @param filepath A single string containing the path or URL to the file to
#' read. Alternatively can be a connection.
#'
#' @param version `readGFF` should do a pretty descent job at detecting
#' the GFF version. Use this argument \emph{only} if it doesn't or if you want
#' to force it to parse and import the file as if its 9-th column was in a
#' different format than what it really is (e.g. specify `version=1` on a
#' GTF or GFF3 file to interpret its 9-th column as the `"group"` column
#' of a GFF1 file). Supported versions are 1, 2, and 3.
#'
#' @param columns The standard GFF columns to load. All of them are loaded by
#' default.
#'
#' @param tags The tags to load. All of them are loaded by default.
#'
#' @param filter `named list()` Specify to load only desired features,
#'   e.g., `list(type = c("gene", "mRNA"), seqid = "chr10")`.
#'
#' @param nrows `-1` or the maximum number of rows to read in (after
#' filtering).
#'
#' @param raw_data `logical(1)` If TRUE, numeric columns (e.g. "start" or
#'   "score") are loaded as character vectors and as-is i.e. how they are found
#'   in the file.
#'
#' @param GFF1 `logical(1)` Use "group" instead of "attributes" for the 9th
#'   column name. Default is `FALSE`.
#'
#' @return A `DataFrame` with columns corresponding to those in the GFF.
#'
#' @author H. Pagès
#'
#' @seealso
#' * [import][GFFFile-class] for importing a GFF file as a
#'   [GenomicRanges::GRanges()] object.
#'
#' * [GenomicRanges::makeGRangesFromDataFrame()] in the
#'   \pkg{GenomicRanges} package for making a [GenomicRanges::GRanges()]
#'   object from a `data.frame` or [S4Vectors::DataFrame()] object.
#'
#' * [txdbmaker::makeTxDbFromGFF()] in the \pkg{txdbmaker}
#'   package for importing a GFF file as a [TxDb][GenomicFeatures::TxDb-class]
#'   object.
#'
#' * The [S4Vectors::DataFrame()] class in the \pkg{S4Vectors} package.
#'
#' @keywords manip
#' @examples
#'
#' ## Standard GFF columns.
#' GFFcolnames()
#' GFFcolnames(GFF1=TRUE)  # "group" instead of "attributes"
#'
#' test_gff3 <- system.file(
#'     "extdata", "genes.gff3", package="Bioc.gff", mustWork=TRUE
#' )
#'
#' ## Load everything.
#' df0 <- readGFF(test_gff3)
#' head(df0)
#'
#' ## Load some tags only (in addition to the standard GFF columns).
#' my_tags <- c("ID", "Parent", "Name", "Dbxref", "geneID")
#' df1 <- readGFF(test_gff3, tags=my_tags)
#' head(df1)
#'
#' ## Load no tags (in that case, the "attributes" standard column
#' ## is loaded).
#' df2 <- readGFF(test_gff3, tags=character(0))
#' head(df2)
#'
#' ## Load some standard GFF columns only (in addition to all tags).
#' my_columns <- c("seqid", "start", "end", "strand", "type")
#' df3 <- readGFF(test_gff3, columns=my_columns)
#' df3
#' table(df3$seqid, df3$type)
#'
#' library(GenomicRanges)
#' makeGRangesFromDataFrame(df3, keep.extra.columns=TRUE)
#'
#' ## Combine use of 'columns' and 'tags' arguments.
#' readGFF(test_gff3, columns=my_columns, tags=c("ID", "Parent", "Name"))
#' readGFF(test_gff3, columns=my_columns, tags=character(0))
#'
#' ## Use the 'filter' argument to load only features of type "gene"
#' ## or "mRNA" located on chr10.
#' my_filter <- list(type=c("gene", "mRNA"), seqid="chr10")
#' readGFF(test_gff3, filter=my_filter)
#' readGFF(test_gff3, columns=my_columns, tags=character(0), filter=my_filter)
#'
NULL

# readGFF() ---------------------------------------------------------------

.make_filexp_from_filepath <- function(filepath) {
    if (isSingleString(filepath))
        return(XVector:::open_input_files(filepath)[[1L]])
    if (!inherits(filepath, "connection"))
        stop(wmsg("'filepath' must be a single string or a connection"))
    if (!base::isSeekable(filepath)) stop(wmsg("connection is not seekable"))
    filepath
}

# readGFFPragmas() --------------------------------------------------------

readGFFPragmas <- function(filepath) {
    filexp <- .make_filexp_from_filepath(filepath)
    if (inherits(filexp, "connection")) {
        if (!base::isOpen(filexp)) {
            base::open(filexp)
            on.exit(base::close(filexp))
        }
        if (base::seek(filexp) != 0) {
            warning(
                wmsg(
                    "connection is not positioned at the start ",
                    "of the file, rewinding it"
                ),
                immediate. = TRUE
            )
            base::seek(filexp, where = 0)
        }
    }
    .Call(read_gff_pragmas, filexp)
}

# sniffGFFVersion() -------------------------------------------------------

.get_version_from_pragmas <- function(pragmas) {
    attrcol_fmt <- attr(pragmas, "attrcol_fmt")
    idx <- grep("^##gff-version", pragmas)
    if (length(idx) == 0L) {
        if (is.null(attrcol_fmt))
            stop(wmsg("'attr(pragmas, \"attrcol_fmt\")' is NULL"))
        return(attrcol_fmt)
    }
    version <- sub("^##gff-version", "", pragmas[idx])
    version <- unique(trimws(version))
    if (length(version) > 1L) {
        warning(wmsg(
            "more than one GFF version specified in the file, ",
            "returning the first one"
        ))
        version <- version[[1L]]
    }
    version <- as.integer(version)
    if (is.na(version)) {
        warning(wmsg("unrecognized GFF version specified in the file"))
        if (is.null(attrcol_fmt))
            stop(wmsg("'attr(pragmas, \"attrcol_fmt\")' is NULL"))
        return(attrcol_fmt)
    }
    version
}

sniffGFFVersion <- function(filepath) {
    pragmas <- readGFFPragmas(filepath)
    .get_version_from_pragmas(pragmas)
}

# GFFcolnames() -----------------------------------------------------------

### Return the 9 standard GFF columns as specified at:
###   http://www.sequenceontology.org/resources/gff3.html

#' @rdname readGFF
#'
#' @export
GFFcolnames <- function(GFF1 = FALSE) {
    if (!isTRUEorFALSE(GFF1)) stop(wmsg("'GFF1' must be TRUE or FALSE"))
    .Call(gff_colnames, GFF1)
}

# readGFF -----------------------------------------------------------------

### Returns 0L, 1L, 2L, or 3L.
#' @importFrom S4Vectors isSingleNumber
.normarg_version <- function(version = 0) {
    if (is.character(version)) {
        ## For compatibility with "import" method for GFFFile objects.
        if (length(version) == 0L) return(0L)
        if (isSingleString(version)) {
            IMPORT_STYLE_VERSIONS <- c("", "1", "2", "3")
            m <- match(version, IMPORT_STYLE_VERSIONS)
            if (is.na(m))
                stop(wmsg(
                    "when a single string, 'version' must ",
                    "be \"\", \"1\", \"2\", or \"3\""
                ))
            version <- m - 1L
            return(version)
        }
    }
    if (isSingleNumber(version)) {
        if (!is.integer(version)) version <- as.integer(version)
        if (version < 0L || version > 3L)
            stop(wmsg("'version' must be 0, 1, 2, or 3"))
        return(version)
    }
    stop(wmsg("'version' must be a single number"))
}

.prepare_colmap_and_tags <- function(
    columns = NULL,
    tags = NULL,
    attrcol_fmt = 0L
) {
    ## Check 'columns'.
    if (!(is.null(columns) || is.character(columns)))
        stop(wmsg("'columns' must be NULL or a character vector"))

    GFF_colnames <- GFFcolnames(attrcol_fmt == 1L)

    ## Check 'tags'.
    if (!is.null(tags)) {
        if (!is.character(tags))
            stop(wmsg("'tags' must be NULL or character vector"))
        if (any(is.na(tags)) || anyDuplicated(tags))
            stop(wmsg("'tags' cannot contain NAs or duplicates"))
        if (attrcol_fmt == 1L) {
            ## Move any GFF colname found in 'tags' to 'columns'.
            columns <- union(columns, intersect(tags, GFF_colnames))
            tags <- setdiff(tags, GFF_colnames)
            if (length(tags) != 0L)
                warning(wmsg("trying to extract tags from a GFF1 file"))
        }
    }

    ## Prepare 'colmap'.
    if (is.null(columns)) {
        colmap <- seq_along(GFF_colnames)
        if (attrcol_fmt != 1L) {
            stopifnot(GFF_colnames[[length(GFF_colnames)]] == "attributes")
            ## We don't load the "attributes" column unless the user
            ## requested no tags (i.e. by setting 'tags' to character(0)).
            if (!(is.character(tags) && length(tags) == 0L))
                colmap[[length(GFF_colnames)]] <- NA_integer_
        }
    } else if (is.character(columns)) {
        if (!all(columns %in% GFF_colnames)) {
            in1string <- paste0(GFF_colnames, collapse = ", ")
            stop(wmsg(
                "'columns' must contain valid GFF columns. ",
                "Valid GFF columns are: ",
                in1string
            ))
        }
        if (anyDuplicated(columns))
            stop(wmsg("'columns' cannot contain duplicates"))
        colmap <- match(GFF_colnames, columns)
    } else {
        stop(wmsg("'columns' must be NULL or a character vector"))
    }

    list(colmap = colmap, tags = tags)
}

.normarg_filter <- function(filter, attrcol_fmt = 0L) {
    GFF_colnames <- GFFcolnames(attrcol_fmt == 1L)
    if (is.null(filter)) return(NULL)
    if (!is.list(filter)) stop(wmsg("'filter' must be NULL or a named list"))
    filter_names <- names(filter)
    if (is.null(filter_names)) stop(wmsg("'filter' must have names"))
    if (attrcol_fmt == 1L) {
        valid_filter_names <- GFF_colnames
    } else {
        valid_filter_names <- head(GFF_colnames, n = -1L)
    }
    if (!all(filter_names %in% valid_filter_names)) {
        in1string <- paste0(valid_filter_names, collapse = ", ")
        if (attrcol_fmt == 1L) {
            excluding_note <- ""
        } else {
            excluding_note <- "(excluding \"attributes\")"
        }
        stop(wmsg(
            "The names on 'filter' must be valid GFF columns ",
            excluding_note,
            ". ",
            "Valid 'filter' names: ",
            in1string
        ))
    }
    if (anyDuplicated(filter_names))
        stop(wmsg("the names on 'filter' must be unique"))
    unname(filter[valid_filter_names])
}

### 'df' must be a data-frame-like object (typically an ordinary data frame or
### a DataFrame object).
.is_multi_tag <- function(df, ntag, attrcol_fmt = 0L) {
    if (ntag == 0L || attrcol_fmt != 3L) return(logical(ntag))
    multi_tags <- c("Parent", "Alias", "Note", "Dbxref", "Ontology_term")
    vapply(
        seq_len(ntag) + ncol(df) - ntag,
        function(j) {
            colnames(df)[[j]] %in%
                multi_tags ||
                any(grepl(",", df[[j]], fixed = TRUE))
        },
        logical(1L)
    )
}

urlDecode <- function(str, na.strings = "NA") {
    ans <- curl::curl_unescape(str)
    if (!identical(na.strings, "NA")) ans[is.na(str)] <- na.strings
    ans
}

### 'df' must be a data-frame-like object (typically an ordinary data frame or
### a DataFrame object). 'decode_idx' must be a non-empty integer vector
### indicating which columns to decode. The columns to decode must be character
### vectors.

#' @importFrom stats setNames
.url_decode_cols <- function(df, decode_idx) {
    decoded_cols <- lapply(
        setNames(decode_idx, colnames(df)[decode_idx]),
        function(j) urlDecode(df[[j]], na.strings = NA_character_)
    )
    df[decode_idx] <- decoded_cols
    df
}

### 'df' must be a data-frame-like object (typically an ordinary data frame or
### a DataFrame object). 'split_idx' must be a non-empty integer vector
### indicating which columns to split. The columns to split must be character
### vectors. Split values are passed thru urlDecode() unless 'raw_data' is
### TRUE. Always returns a DataFrame.
.strsplit_cols <- function(df, split_idx, raw_data) {
    split_cols <- lapply(
        setNames(split_idx, colnames(df)[split_idx]),
        function(j) {
            col <- df[[j]]
            ## Probably the most efficient way to create an empty CharacterList
            ## of arbitrary length.
            split_col <- relist(
                character(0),
                PartitioningByEnd(rep.int(0L, length(col)))
            )
            not_na <- !is.na(col)
            tmp <- strsplit(col[not_na], ",", fixed = TRUE)
            split_col[not_na] <- IRanges::CharacterList(tmp)
            if (raw_data) return(split_col)
            relist(urlDecode(unlist(split_col)), split_col)
        }
    )
    ## Surprisingly sticking the CharacterList cols back into 'df' works
    ## even if 'df' is an ordinary data frame!
    df[split_idx] <- split_cols
    ans <- DataFrame(df, check.names = FALSE)
    ## "show" method for DataFrame is broken if some colnames are the empty
    ## string so we rename this column (in our case, we know there can only
    ## be one).
    m <- match("", colnames(ans))
    if (!is.na(m)) colnames(ans)[m] <- "__empty_tag__"
    ans
}

#' @rdname readGFF
#'
#' @export
readGFF <- function(
    filepath,
    version = 0,
    columns = NULL,
    tags = NULL,
    filter = NULL,
    nrows = -1,
    raw_data = FALSE
) {
    ## Check 'filepath'.
    filexp <- .make_filexp_from_filepath(filepath)
    if (inherits(filexp, "connection")) {
        if (!base::isOpen(filexp)) {
            base::open(filexp)
            on.exit(base::close(filexp))
        }
        if (base::seek(filexp) != 0) {
            warning(
                wmsg(
                    "connection is not positioned at the start ",
                    "of the file, rewinding it"
                ),
                immediate. = TRUE
            )
            base::seek(filexp, where = 0)
        }
    }

    ## Check 'version'.
    version <- .normarg_version(version)

    ## Get pragmas lines.
    pragmas <- .Call(read_gff_pragmas, filexp)

    ## Rewind file.
    if (inherits(filexp, "connection")) {
        base::seek(filexp, where = 0)
    } else {
        XVector:::rewind_filexp(filexp)
    }

    if (version == 0L) {
        attrcol_fmt <- .get_version_from_pragmas(pragmas)
    } else {
        attrcol_fmt <- version
    }

    ## Prepare 'colmap' and normalize 'tags'.
    colmap_and_tags <- .prepare_colmap_and_tags(columns, tags, attrcol_fmt)
    colmap <- colmap_and_tags$colmap
    tags <- colmap_and_tags$tags

    ## Normalize 'filter'.
    filter <- .normarg_filter(filter, attrcol_fmt)

    ## Normalize 'nrows'.
    if (!isSingleNumber(nrows)) stop(wmsg("'nrows' must be a single number"))
    if (!is.integer(nrows)) nrows <- as.integer(nrows)

    ## Check 'raw_data'.
    if (!isTRUEorFALSE(raw_data)) stop(wmsg("'raw_data' must be TRUE or FALSE"))

    ## 1st pass.
    scan_ans <- .Call(scan_gff, filexp, attrcol_fmt, tags, filter, nrows)
    if (is.null(tags)) tags <- scan_ans[[1L]]
    nrows <- scan_ans[[2L]]

    ## Rewind file.
    if (inherits(filexp, "connection")) {
        base::seek(filexp, where = 0)
    } else {
        XVector:::rewind_filexp(filexp)
    }

    ## 2nd pass: return 'ans' as an ordinary data frame.
    ans <- .Call(
        load_gff,
        filexp,
        attrcol_fmt,
        tags,
        filter,
        nrows,
        pragmas,
        colmap,
        raw_data
    )
    ncol0 <- attr(ans, "ncol0")
    ntag <- attr(ans, "ntag") # should be the same as 'length(tags)'

    ## Post-process standard GFF cols.
    if (!raw_data) {
        if (attrcol_fmt == 1L) {
            #factor_colnames <- c("seqid", "source", "type", "strand", "group")
            factor_colnames <- c("seqid", "source", "type", "group")
        } else {
            #factor_colnames <- c("seqid", "source", "type", "strand")
            factor_colnames <- c("seqid", "source", "type")
        }
        m <- match(factor_colnames, head(colnames(ans), n = ncol0))
        m <- m[!is.na(m)]
        factor_cols <- lapply(
            setNames(m, colnames(ans)[m]),
            function(j) factor(ans[[j]], levels = unique(ans[[j]]))
        )
        ans[m] <- factor_cols
    }

    ## Post-process tags.
    if (ntag != 0L) {
        is_multi_tag <- .is_multi_tag(ans, ntag, attrcol_fmt)
        if (!raw_data) {
            decode_idx <- which(!is_multi_tag) + ncol0
            if (length(decode_idx) != 0L)
                ans <- .url_decode_cols(ans, decode_idx)
        }
        split_idx <- which(is_multi_tag) + ncol0
        if (length(split_idx) != 0L) {
            ## Returns 'ans' as a DataFrame.
            ans <- .strsplit_cols(ans, split_idx, raw_data)
        }
    }

    ## 'ans' could have lost its readGFF-specific attributes (e.g. if it was
    ## turned into a DataFrame), so we restore them and cross our fingers that
    ## they won't clash with the DataFrame slots the day the internals of
    ## DataFrame objects happen to change (very unlikely though).
    if (is.null(attr(ans, "pragmas"))) attr(ans, "pragmas") <- pragmas
    if (is.null(attr(ans, "attrcol_fmt")))
        attr(ans, "attrcol_fmt") <- attrcol_fmt
    if (is.null(attr(ans, "ncol0"))) attr(ans, "ncol0") <- ncol0
    if (is.null(attr(ans, "ntag"))) attr(ans, "ntag") <- ntag
    if (is.null(attr(ans, "raw_data"))) attr(ans, "raw_data") <- raw_data
    ans
}

# readGFFAsGRanges() ------------------------------------------------------

### Used in "import" method for GFFFile objects.
### Not exported (user should use import()).

### sequence-region => Seqinfo -- by Michael
#' @importFrom utils read.table
#' @importFrom Seqinfo Seqinfo
.parseSequenceRegionsAsSeqinfo <- function(lines) {
    sr <- grep("##sequence-region", lines, value = TRUE)
    srcon <- file()
    on.exit(base::close(srcon))
    writeLines(sr, srcon)
    srt <- read.table(
        srcon,
        comment.char = "",
        colClasses = list(NULL, "character", "integer", "integer")
    )
    if (any(srt[[2L]] != 1L)) {
        warning(
            "One or more ##sequence-region directives do not start at 1. ",
            "The assumptions made by 'sequenceRegionsAsSeqinfo=TRUE' ",
            "have been violated."
        )
    }
    Seqinfo(srt[[1L]], srt[[3L]])
}

### -- by Michael, updated by Marcel
.parseSpeciesAsMetadata <- function(lines) {
    species <- unique(grep("##species", lines, fixed = TRUE, value = TRUE))
    if (length(species) > 1L) stop("multiple species definitions found")
    metadata <- list()
    if (identical(length(species), 1L)) {
        species <- sub("##species ", "", species, fixed = TRUE)
        if (isNCBISpeciesURL(species))
            metadata <- tryCatch(
                {
                    metadataFromNCBI(species)
                },
                error = function(e) {
                    warning("failed to retrieve organism information from NCBI")
                }
            )
    }
    metadata
}

#' @importFrom Seqinfo seqlevels seqlevels<- seqinfo<- genome<-
#' @importFrom S4Vectors isSingleStringOrNA metadata<-
#' @importFrom GenomicRanges makeGRangesFromDataFrame
readGFFAsGRanges <- function(
    filepath,
    version = 0,
    colnames = NULL,
    filter = NULL,
    genome = NA,
    sequenceRegionsAsSeqinfo = FALSE,
    speciesAsMetadata = FALSE
) {
    if (!(isSingleStringOrNA(genome) || is(genome, "Seqinfo")))
        stop(wmsg(
            "'genome' must be a single string or NA, ",
            "or a Seqinfo object"
        ))
    if (!isTRUEorFALSE(sequenceRegionsAsSeqinfo))
        stop(wmsg("'sequenceRegionsAsSeqinfo' must be TRUE or FALSE"))
    if (!isTRUEorFALSE(speciesAsMetadata))
        stop(wmsg("'speciesAsMetadata' must be TRUE or FALSE"))

    ## Read as data frame.
    if (is.null(colnames)) {
        df <- readGFF(filepath, version = version, filter = filter)
    } else {
        if (!is.character(colnames))
            stop(wmsg("'colnames' must be a character vector"))
        ## Split 'colnames' between 'columns' and 'tags'.
        GFF_colnames <- GFFcolnames()
        columns <- intersect(colnames, GFF_colnames)
        tags <- setdiff(colnames, GFF_colnames)
        core_columns <- c("seqid", "start", "end", "strand")
        columns <- union(columns, core_columns)
        df <- readGFF(
            filepath,
            version = version,
            columns = columns,
            tags = tags,
            filter = filter
        )
    }

    ## Turn data frame into GRanges.
    ## TODO: Maybe we should be able to pass the metadata to
    ## makeGRangesFromDataFrame()?
    if (is.null(colnames)) {
        ans <- makeGRangesFromDataFrame(
            df,
            keep.extra.columns = TRUE,
            seqnames.field = "seqid"
        )
    } else {
        ans <- makeGRangesFromDataFrame(df, seqnames.field = "seqid")
        mcols(ans) <- df[, colnames, drop = FALSE]
    }

    ## Set seqinfo.
    ans_seqinfo <- NULL
    pragmas <- attr(df, "pragmas")
    attrcol_fmt <- attr(df, "attrcol_fmt")
    if (sequenceRegionsAsSeqinfo && attrcol_fmt == 3L) {
        ## Get 'ans_seqinfo' from pragmas.
        ans_seqinfo <- .parseSequenceRegionsAsSeqinfo(pragmas)
    } else if (is(genome, "Seqinfo")) {
        ans_seqinfo <- genome
        if (!all(seqlevels(ans) %in% seqlevels(ans_seqinfo)))
            stop(wmsg(
                "the sequence names in the GTF or GFF file are in ",
                "disagreement with the Seqinfo object specified via ",
                "the 'genome' argument"
            ))
    } else if (isSingleString(genome)) {
        ans_seqinfo <- Seqinfo::Seqinfo(genome = genome)
        if (
            !is.null(ans_seqinfo) &&
                !all(seqlevels(ans) %in% seqlevels(ans_seqinfo))
        ) {
            warning(wmsg(
                "cannot set the seqlengths or circularity flags on ",
                "the GRanges object to return because the sequence ",
                "names in the GTF or GFF file are in disagreement ",
                "with the sequence names implied by the genome ",
                "assembly (",
                genome,
                ") specified via the 'genome' ",
                "argument"
            ))
            ans_seqinfo <- NULL
        }
    }
    if (!is.null(ans_seqinfo)) {
        seqlevels(ans) <- seqlevels(ans_seqinfo)
        seqinfo(ans) <- ans_seqinfo
    }
    if (isSingleString(genome)) genome(ans) <- genome

    ## Get 'ans_metadata' from pragmas.
    if (speciesAsMetadata) {
        ans_metadata <- .parseSpeciesAsMetadata(pragmas)
    } else {
        ans_metadata <- list()
    }

    metadata(ans) <- ans_metadata
    ans
}

# Separate index support --------------------------------------------------

# queryForResource --------------------------------------------------------

## There is some question as to whether the import routines should
## recurse through import.tabix, or perform the query
## internally. Currently, we are taking the latter route, because it
## is consistent with (gzip) decoding and it allows the parsers more
## flexibility.

setGeneric(
    "queryForResource",
    function(manager, x, which = NULL, ...) standardGeneric("queryForResource"),
    signature = "x"
)

## Attaches 'usedWhich' attribute, an optimization hint indicating
## that subsetting by 'which' has been performed and is no longer
## necessary. Probably premature.

setMethod(
    "queryForResource",
    "BiocFile",
    function(manager, x, which = NULL, ...) {
        r <- resource(x)
        ans <- structure(r, usedWhich = FALSE)
        if (!is.null(which) && is.character(r)) {
            x_tbi <- paste(r, "tbi", sep = ".")
            if (file.exists(x_tbi))
                ans <- queryForResource(
                    manager,
                    Rsamtools::TabixFile(r),
                    which = which,
                    ...
                )
        }
        ans
    }
)

connectionForResource <- BiocIO:::connectionForResource
manage <- BiocIO:::manage

#' @importFrom Seqinfo seqinfo
#' @importFrom Rsamtools headerTabix scanTabix
#' @importFrom BiocGenerics path
#' @importClassesFrom Rsamtools TabixFile
setMethod(
    "queryForResource",
    "TabixFile",
    function(manager, x, which, header = TRUE, ...) {
        tabixHeader <- headerTabix(x)
        si <- Seqinfo(tabixHeader$seqnames)
        if (is.null(which)) {
            buffer <- connectionForResource(manager, path(x), "r")
            if (!header) readLines(buffer, tabixHeader$skip)
        } else {
            buffer <- manage(manager, file())
            if (header) {
                skippedLines <- readLines(path(x), tabixHeader$skip)
                writeLines(skippedLines, buffer)
            }
            lines <- unlist(
                scanTabix(x, param = which),
                use.names = FALSE
            )
            writeLines(lines, buffer)
            si <- merge(si, seqinfo(which))
        }
        structure(buffer, usedWhich = TRUE, seqinfo = si)
    }
)

queryForConnection <- function(manager, x, which = NULL, ...) {
    resource <- queryForResource(manager, x, which = which, ...)
    con <- connectionForResource(manager, resource, open = "r")
    structure(con, usedWhich = attr(resource, "usedWhich"))
}

.NCBI_TAX_URL <- "https://www.ncbi.nlm.nih.gov/Taxonomy/Browser/wwwtax.cgi"

#' @name metadataFromNCBI
isNCBISpeciesURL <- function(url) {
    grepl("taxonomy/browser", url, ignore.case = TRUE)
}

#' Obtain metadata from NCBI
#'
#' These helper functions obtain both the Taxonomy ID and the Organism name from
#' the NCBI Taxonomy Browser. They are a modern re-write of the old functions in
#' `rtracklayer`. They use `httr2` and `rvest` to parse the HTML content.
#'
#' @param url A URL to the NCBI Taxonomy Browser, typically obtained from a
#' GFF file with the `## species` line.
#'
#' @returns
#' * metadataFromNCBI: A `list` with two elements: `Taxonomy ID` and
#'   `Organism`.
#' * parseOrganismFromNCBI: A `character` with the Organism name.
#' * isNCBISpeciesURL: A `logical` indicating if the URL is from the NCBI
#'   Taxonomy Browser.
#' * parseTaxonomyIDFromNCBI: A `character` with the Taxonomy ID.
#'
#' @keywords internal
#' @examples
#' \donttest{
#'   isNCBISpeciesURL(.NCBI_TAX_URL)
#'
#'   metadataFromNCBI(
#'       paste0(.NCBI_TAX_URL, "?mode=Info&id=9606")
#'   )
#'   metadataFromNCBI(
#'       paste0(.NCBI_TAX_URL, "?id=3702")
#'   )
#'   metadataFromNCBI(
#'       paste0(.NCBI_TAX_URL, "?name=drosophila+melanogaster")
#'   )
#'   metadataFromNCBI(
#'       paste0(.NCBI_TAX_URL, "?name=drosophila+miranda")
#'   )
#' }
#' @importFrom BiocBaseUtils checkInstalled
metadataFromNCBI <- function(url) {
    BiocBaseUtils::checkInstalled(c("httr2", "rvest"))
    res_html <- httr2::request(url) |>
        httr2::req_perform() |>
        httr2::resp_body_html()
    Organism <- parseOrganismFromNCBI(res_html)
    Taxonomy_ID <- parseTaxonomyIDFromNCBI(res_html, url)
    list(
        "Taxonomy ID" = Taxonomy_ID,
        "Organism" = Organism
    )
}

#' @rdname metadataFromNCBI
parseOrganismFromNCBI <- function(html) {
    html |>
        rvest::html_elements("h2") |>
        rvest::html_text() |>
        tolower()
}

#' @rdname metadataFromNCBI
parseTaxonomyIDFromNCBI <- function(html, url) {
    if (grepl("id=", url, fixed = TRUE)) {
        httr2::url_parse(url)[[c("query", "id")]]
    } else {
        html |>
            rvest::html_elements(xpath = "/html/body/div[2]/div[2]") |>
            rvest::html_text() |>
            gsub(".*Taxonomy ID: (\\d+).*", "\\1", x = _)
    }
}

.NCBI_TAX_URL <- Bioc.gff:::.NCBI_TAX_URL

Bioc.gff:::isNCBISpeciesURL(.NCBI_TAX_URL)

response <- Bioc.gff:::metadataFromNCBI(
    paste0(.NCBI_TAX_URL, "?mode=Info&id=9606")
)
expect_identical(
    response,
    list(`Taxonomy ID` = "9606", Organism = "homo sapiens")
)

response <- Bioc.gff:::metadataFromNCBI(
    paste0(.NCBI_TAX_URL, "?id=3702")
)
expect_identical(
    response,
    list(`Taxonomy ID` = "3702", Organism = "arabidopsis thaliana")
)

# Utilities ---------------------------------------------------------------

scanGFFDirectives <- function(con, tag = NULL) {
    m <- manager()
    con <- connection(m, con, "r")
    on.exit(release(m, con))
    directives <- character()
    lines <- line <- readLines(con, n = 1)
    while (grepl("^#", line)) {
        if (grepl("^##", line)) {
            directives <- c(directives, line)
        }
        line <- readLines(con, n = 1)
        if (length(line) == 0L) break
        lines <- c(lines, line)
    }
    pushBack(lines, con)
    sub(
        "^[^[:space:]]* ",
        "",
        grep(paste0("^##", tag), directives, value = TRUE)
    )
}

gffGenomeBuild <- function(x) {
    genome_build <- scanGFFDirectives(x, "genome-build")
    unlist(strsplit(genome_build, "\t", fixed = TRUE))
}

#' @importFrom Seqinfo provider providerVersion genome
setMethod("provider", "GFFFile", function(x) {
    gffGenomeBuild(x)[1]
})

setMethod("providerVersion", "GFFFile", function(x) {
    gffGenomeBuild(x)[2]
})

#' @describeIn GFFFile-class Gets the genome identifier from the "genome-build"
#'   header directive.
#'
#' @exportMethod genome
setMethod("genome", "GFFFile", function(x) providerVersion(x))

gffComment <- function(con, ...)
    cat("##", paste(...), "\n", sep = "", file = con, append = TRUE)

.sniffGFFVersion <- function(con) {
    version <- NULL
    lines <- line <- readLines(con, n = 1)
    while (grepl("^#", line)) {
        if (grepl("^##gff-version", line)) {
            version <- sub("^##gff-version *", "", line)
            break
        }
        line <- readLines(con, n = 1)
        lines <- c(lines, line)
    }
    pushBack(lines, con)
    version
}

gffFileClass <- function(version) {
    paste("GFF", version, "File", sep = "")
}

gffFileVersion <- function(file) {
    versions <- c("1", "2", "3")
    unlist(Filter(function(v) is(file, gffFileClass(v)), versions))
}

asGFFVersion <- function(con, version) {
    if (!is(con, gffFileClass(version))) {
        if (!is(con, "GFFFile"))
            warning(
                "Treating a '",
                class(con),
                "' as GFF version '",
                version,
                "'"
            )
        con <- GFFFile(resource(con), version)
    }
    con
}

#' @importFrom S4Vectors isSingleString
pasteCollapse <- function(x, collapse = ",") {
    if (!is(x, "CharacterList")) stop("'x' must be a CharacterList")
    if (!isSingleString(collapse) || nchar(collapse) != 1L)
        stop("'collapse' must be a single string, with a single character")
    x <- as.list(x)
    .Call(CharacterList_pasteCollapse, x, collapse)
}

## taken from rtracklayer:::checkArgFormat
checkArgFormat <-
    function(con, format) {
        if (
            toupper(format) !=
                substring(
                    toupper(sub("File$", "", class(con))),
                    1,
                    nchar(format)
                )
        )
            stop("Cannot treat a '", class(con), "' as format '", format, "'")
    }

## adapted from rtracklayer:::singleGenome
#' @importFrom BiocBaseUtils isScalarCharacter
singleGenome <-
    function(x) {
        x1 <- unname(unique(x))
        if (!isScalarCharacter(x1, na.ok = TRUE))
            stop("Multiple genomes encountered; only one supported")
        x1
    }

## taken from rtracklayer:::urlEncode
urlEncode <-
    function(str, chars = "-a-zA-Z0-9$_.+!*'(),", keep = TRUE) {
        str <- as.character(str)
        bad <- chars
        if (keep) bad <- gsub(paste("[", chars, "]", sep = ""), "", str)
        bad <- unique(unlist(strsplit(bad, "")))
        code <- paste("%", charToRaw(paste(bad, collapse = "")), sep = "")
        for (i in seq_along(bad))
            str <- gsub(bad[i], code[i], str, fixed = TRUE)
        str
    }

## getMethod(rtracklayer:::sortBySeqnameAndStart, "GenomicRanges")
.sortBySeqnameAndStart <- function(x) {
    x[order(as.factor(seqnames(x)), start(x)), ]
}

## taken from rtracklayer:::uriIsLocal
uriIsLocal <- function(x) {
    x$scheme == "file" || x$scheme == ""
}

## taken from rtracklayer:::indexTrack
#' @importFrom Rsamtools bgzip indexTabix TabixFile
indexTrack <- function(con, ...) {
    indexed <- NULL
    formats <- eval(formals(indexTabix)$format)
    uri <- path(con)
    parsed_uri <- BiocIO:::.parseURI(uri)
    if (!uriIsLocal(parsed_uri)) stop("'con' must be a path to a local file")
    original_path <- parsed_uri$path
    path <- bgzip(original_path, overwrite = TRUE)
    format <- Find(
        function(f) {
            is(con, paste(toupper(f), "File", sep = ""))
        },
        formats
    )
    if (!is.null(format)) {
        indexTabix(path, format, ...)
    } else {
        indexTabix(path, ...)
    }
    indexed <- TabixFile(path)
    unlink(original_path)
    invisible(indexed)
}

library(IRanges)

pasteCollapse <- Bioc.gff:::pasteCollapse

## Test pasteCollapse
cl <- CharacterList(c("a", "b"), "c", c("d", "e", "f"))
expect_equal(pasteCollapse(cl), c("a,b", "c", "d,e,f"))
expect_equal(pasteCollapse(cl, collapse = "|"), c("a|b", "c", "d|e|f"))

## Test error on wrong input type for x
not_cl <- list(c("a", "b"), "c")
expect_error(
    pasteCollapse(not_cl),
    "'x' must be a CharacterList"
)

## Test error on invalid collapse argument
expect_error(
    pasteCollapse(cl, collapse = ",,"),
    "'collapse' must be a single string, with a single character"
)

## Test with empty CharacterList
cl_empty <- CharacterList()
expect_equal(pasteCollapse(cl_empty), character(0))

## Test with CharacterList containing empty elements
cl_with_empty <- CharacterList(c("a", ""), character(0), c("b", "c"))
expect_equal(pasteCollapse(cl_with_empty), c("a,", "", "b,c"))

# Coercion ----------------------------------------------------------------

#' @name asGFF
#'
#' @title Coerce to GFF structure
#'
#' @description Coerce the structure of an object to one following GFF-like
#'   conventions, i.e., using the `Parent` GFF3 attribute to encode the
#'   hierarchical structure. This object is then suitable for export as GFF3.
#'
#' @param x Generally, a tabular object to structure as GFF(3)
#'
#' @param parentType The value to store in the `type` column for the
#' top-level (e.g., transcript) ranges.
#'
#' @param childType The value to store in the `type` column for the child
#' (e.g., exon) ranges.
#'
#' @param \dots Arguments to pass to methods
#'
#' @return For the `GRangesList` method: A `GRanges`, with the columns: `ID`
#'   (unique identifier), `Name` (from `names(x)`, and the names on each
#'   element of `x`, if any), `type` (as given by `parentType` and `childType`),
#'   and `Parent` (to relate each child range to its parent at the top-level).
#'
#' @author Michael Lawrence
#'
#' @examples
#' library(TxDb.Hsapiens.UCSC.hg19.knownGene)
#' library(GenomicFeatures)
#' exons <- exonsBy(TxDb.Hsapiens.UCSC.hg19.knownGene)
#' mcols(asGFF(exons))
#' @export
setGeneric("asGFF", function(x, ...) standardGeneric("asGFF"))

#' @describeIn asGFF Coerce to GFF GRanges structure
#' @importFrom S4Vectors values values<- elementNROWS
#'
#' @exportMethod asGFF
setMethod(
    "asGFF",
    "GRangesList",
    function(x, parentType = "mRNA", childType = "exon") {
        parent_range <- range(x)
        if (!all(elementNROWS(parent_range) == 1))
            stop("Elements in a group must be on same sequence and strand")
        parents <- unlist(parent_range, use.names = FALSE)
        children <- unlist(x, use.names = FALSE)
        makeId <- function(x, prefix) {
            paste(prefix, seq_len(length(x)), sep = "")
        }
        parentIds <- makeId(parents, parentType)
        values(parents)$type <- parentType
        values(parents)$ID <- parentIds
        values(parents)$Name <- names(x)
        values(children)$type <- childType
        values(children)$ID <- makeId(children, childType)
        values(children)$Name <- names(children)
        values(children)$Parent <- rep.int(parentIds, elementNROWS(x))
        allColumns <- union(
            colnames(values(parents)),
            colnames(values(children))
        )
        values(children) <- rectifyDataFrame(values(children), allColumns)
        values(parents) <- rectifyDataFrame(values(parents), allColumns)
        c(parents, children)
    }
)

#' @importFrom S4Vectors DataFrame
rectifyDataFrame <- function(x, allColumns) {
    x[setdiff(allColumns, colnames(x))] <- DataFrame(NA)
    x[allColumns]
}

### FIXME: We wrote this but never tested it, and it is not yet
### used. People should use GFF3 instead of this.
###
### KNOWN ISSUES:
### 1) The stop codon should not be included in the CDS (annoying)
### 2) pmapFromTranscripts() does not yet support our usage of it
### 3) Needs to move to GenomicFeatures

setGeneric("asGTF", function(x, ...) standardGeneric("asGTF"))

#' @importFrom BiocGenerics width end
#' @importFrom IRanges PartitioningByEnd
#' @importFrom utils head
frame <- function(x) {
    cs <- cumsum(width(x))
    ucs <- unlist(cs, use.names = FALSE)
    ucs[end(PartitioningByEnd(x))] <- 0L
    ucs <- c(0L, head(ucs, -1L))
    ucs %% 3L
}

#' @importFrom IRanges IRanges togroup PartitioningByWidth
#' @importFrom GenomicRanges mcols mcols<-
setMethod("asGTF", "GRangesList", function(x) {
    tx_ids <- names(x)
    if (is.null(tx_ids)) {
        tx_ids <- seq_along(x)
    }
    processFeatures <- function(f) {
        ans <- unlist(f, use.names = FALSE)
        ans$frame <- frame(f)
        if (is.null(ans$gene_id)) {
            ans$gene_id <- ""
        }
        if (is.null(ans$transcript_id)) {
            ans$transcript_id <- tx_ids[togroup(PartitioningByWidth(f))]
        }
        ans
    }
    start_codon_tx <-
        GenomicFeatures::pmapFromTranscripts(IRanges(1L, 3L), x)
    start_codon <- processFeatures(start_codon_tx)
    mcols(start_codon)$type <- "start_codon"
    stop_ranges <- IRanges(end = sum(width(x)), width = 3L)
    stop_codon_tx <-
        GenomicFeatures::pmapFromTranscripts(stop_ranges, x)
    stop_codon <- processFeatures(stop_codon_tx)
    mcols(stop_codon)$type <- "stop_codon"
    codons <- c(start_codon, stop_codon)
    cds <- processFeatures(x)
    mcols(cds)$type <- "CDS"
    values(codons) <- rectifyDataFrame(values(codons), colnames(cds))
    c(codons, cds)
})

## setMethod("asGTF", "TxDb",
##           function(x, by) {
##               cds <- cds(x, columns="tx_id")
##               cds <- cds[togroup(cds$tx_id)]
##               cds$transcript_id <- unlist(cds$tx_id)
##               cds$tx_id <- NULL
##               txGene <- transcriptsBy(x)
##               txToGene <- setNames(names(txGene)[togroup(txGene)],
##                                    unlist(txGene, use.names=FALSE)$tx_id)
##               cds$gene_id <- txToGene[cds$transcript_id]
##               processUTRs <- function(utr) {
##                   ans <- unlist(utr, use.names=FALSE)
##                   ans$transcript_id <- names(utr)[togroup(utr)]
##                   ans$gene_id <- txToGene[ans$transcript_id]
##                   ans
##               }
##               three_utr <- processUTRs(threeUTRsByTranscript(x))
##               three_utr$type <- "3UTR"
##               five_utr <- processUTRs(fiveUTRsByTranscript(x))
##               five_utr$type <- "5UTR"
##               c(asGTF(split(cds, cds$transcript_id)), five_utr, three_utr)
##           })

library(GenomicRanges)
library(tinytest)

## Test asGFF on a simple GRangesList
grl <- GRangesList(
    tx1 = GRanges("chr1", IRanges(c(1, 10), c(5, 15)), "+"),
    tx2 = GRanges("chr1", IRanges(c(20, 30), c(25, 35)), "-")
)

gff <- asGFF(grl)

expect_true(inherits(gff, "GRanges"))
expect_equal(length(gff), 6)
expect_equal(sum(gff$type == "mRNA"), 2)
expect_equal(sum(gff$type == "exon"), 4)
parents <- gff[gff$type == "mRNA"]
children <- gff[gff$type == "exon"]
expect_true(all(children$Parent %in% parents$ID))

## Test error when elements are on different sequences
grl_error_seq <- GRangesList(
    tx1 = GRanges(c("chr1", "chr2"), IRanges(c(1, 10), c(5, 15)), "+")
)
expect_error(
    asGFF(grl_error_seq),
    "Elements in a group must be on same sequence and strand"
)

## Test error when elements are on different strands
grl_error_strand <- GRangesList(
    tx1 = GRanges("chr1", IRanges(c(1, 10), c(5, 15)), c("+", "-"))
)
expect_error(
    asGFF(grl_error_strand),
    "Elements in a group must be on same sequence and strand"
)

---
title: "Bioc.gff: GFF3 File Format Support"
author: "Michael Lawrence"
date: "`r format(Sys.Date(), '%B %d, %Y')`"
vignette: >
  %\VignetteIndexEntry{Bioc.gff: GFF3 File Format Support}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
output:
  BiocStyle::html_document:
    number_sections: yes
    toc: true
package: Bioc.gff
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(
    cache = TRUE,
    comment = "#>"
)
library(BiocStyle)
```

# Bioc.gff

## Introduction

The `r Biocpkg("Bioc.gff")` package provides support for the General Feature
Format (GFF) file format, which is widely used for representing genomic features
and annotations. This package allows users to read, write, and manipulate GFF
versions 1, 2 (GTF), and 3 in R, making it easier to work with genomic data.

While the `r Biocpkg("rtracklayer")` package offers robust GFF support, it is a
large package with many features beyond file import. `Bioc.gff` fills a specific
niche in the Bioconductor ecosystem by providing a lightweight, focused solution
with minimal dependencies. This modularity is beneficial for developers of other
packages who need to parse GFF files without inheriting the extensive dependency
footprint of `rtracklayer`. For the end user, it offers a simple and direct
interface for GFF manipulation.

Note that much of the code in the package is ported and adapted from the
`r Biocpkg("rtracklayer")` Bioconductor package. The intention is that the GFF
functionality residing in `r Biocpkg("rtracklayer")` will be removed from 
that package in favor of using `Bioc.gff`, thereby reducing its size and
complexity.

# Installation

You can install the `Bioc.gff` package from Bioconductor using the following:

```{r install, eval=FALSE}
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")

BiocManager::install("Bioc.gff")
```

# Loading packages

```{r load}
library(Bioc.gff)
library(GenomicRanges)
```

# Usage

The `Bioc.gff` package provides functions to read and write GFF files, as well
as to manipulate GFF data structures. The following sections provide some
examples of how to use the package.

## Reading GFF Files

You can read GFF files using the `readGFF` function. This function supports
GFF versions 1, 2, and 3. The following example demonstrates how to read a GFF
file:

```{r find-gff}
gff_file <- system.file("extdata", "genes.gff3", package = "Bioc.gff")
```

### Using the `import` function

The `import` function deduces that the input string is a GFF file type and calls
the appropriate method for reading the GFF file.

```{r read-gff}
import(gff_file)
```

Here the output object is a `GRanges` class, which contains genomic coordinates
and associated metadata. The `GRanges` object indicates the ranges with the
`seqnames`, `ranges`, and `strand`,  columns. The associated metadata is
stored in the `mcols` slot, which (in this example) includes attributes like
`source`, `type`, `phase`, `ID`, `Name`, `geneName`, `Alias` and `genome`.

#### Selectively importing ranges

You can also selectively import ranges from the GFF file using the `which`
argument. This allows you to filter the data based on specific criteria, such as
chromosome or strand. For example, to import only the ranges on chromosome 1:

```{r read-gff-which}
which <- GRanges("chr10:90000-93000")
import(gff_file, which = which, genome = "hg19")
```

Note that you can indicate the genome build using the `genome` argument, which
is useful for ensuring that the imported data is compatible with other genomic
data you may be working with.

### Using the `readGFF` function

As an alternative, you can use the `readGFF` function directly, which is
more explicit about the GFF version:

```{r read-gff-version}
readGFF(gff_file, version = "3")
```

This function returns a `DataFrame` object, which contains the same information
as the `GRanges` object but in a tabular format. Note that one can use the
`makeGRangesFromDataFrame` function to convert the `DataFrame` returned by
`readGFF` into a `GRanges` object, which is often more convenient for downstream
analysis:

```{r read-gff-granges}
readGFF(gff_file, version = "3") |>
    makeGRangesFromDataFrame(
        keep.extra.columns = TRUE
    )
```

### Reading remote GFF files

You can also read GFF files from remote URLs. The `import` function can handle
URLs directly, allowing you to read GFF files hosted on remote servers. 
In this example, we read a GFF3 file from the miRBase database:

```{r read-gff-remote-direct,eval=FALSE}
remote_gff_url <- "https://www.mirbase.org/download/hsa.gff3"
import(remote_gff_url, version = "3")
```

To show the example output in the vignette, a more advanced approach is used
below. This is done to avoid repeated downloads of the remote file when the
vignette is re-built on the Bioconductor Build System (BBS). We use the
`BiocFileCache` package to cache the file locally.

```{r read-gff-remote}
library(BiocFileCache)
bfc <- BiocFileCache::BiocFileCache()
remote_gff_url <- "https://www.mirbase.org/download/hsa.gff3"
bquery <- bfcquery(bfc, remote_gff_url, "rname", exact = TRUE)
if (!nrow(bquery))
    bfcadd(x = bfc, rname = remote_gff_url, rtype = "web", download = TRUE)
gff_local <- bfcrpath(
    bfc, rnames = remote_gff_url, exact = TRUE, download = FALSE, rtype = "web"
)
```

Finally, the relevant function remains the same for reading a GFF file i.e.,
via `import()`:

```{r read-gff-remote2}
import(gff_local, version = "3")
```

## Conversion to GFF

While `TxDb` objects are highly efficient for querying transcript annotations
within R, it is often necessary to export this data to a standard, portable
format for use with external tools or for sharing with collaborators. The GFF3
format is a widely accepted standard for this purpose. Converting a `TxDb` or a
derivative object (like a `GRangesList` of exons) into a GFF3-compatible
`GRanges` object allows for easy export. This is particularly useful for
visualizing annotations in genome browsers like IGV or UCSC, or for input into
downstream analysis pipelines that expect GFF3 files.

```{r as-gff}
library(GenomicFeatures)
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
txdb <- TxDb.Hsapiens.UCSC.hg19.knownGene
exonsBy(txdb, by = "tx") |>
    asGFF()
```

## GFF to TxDb

You can convert a `GFF` object to a `TxDb` object using the `makeTxDbFromGFF`
in the `r Biocpkg("txdbmaker")` package. This is useful for creating a
transcript database from GFF annotations, which can then be used for various
genomic analyses.

```{r make-txdb-from-gff}
library(txdbmaker)
txdb <- makeTxDbFromGFF(
    file = gff_local,
    format = "gff3",
    dataSource = "https://www.mirbase.org/download/hsa.gff3",
    organism = "Homo sapiens",
    taxonomyId = 9606
)
genome <- grepv("genome-build-id", readLines(gff_local)) |>
    strsplit("# genome-build-id:\\s+") |>
    unlist() |>
    tail(1L)
genome(txdb) <- genome
txdb
```

# SessionInfo

```{r session-info}
sessionInfo()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/Bioc.gff-package.R
\docType{package}
\name{Bioc.gff-package}
\alias{Bioc.gff}
\alias{Bioc.gff-package}
\title{Bioc.gff: Read and write GFF and GTF files}
\description{
Parse GFF and GTF files using C++ classes. The package also provides utilities to read and write GFF3 files. The GFF (General Feature Format) format is a tab-delimited file format for describing genes and other features of DNA, RNA, and protein sequences. GFF files are often used to describe the features of genomes.
}
\seealso{
Useful links:
\itemize{
  \item \url{https://github.com/Bioconductor/Bioc.gff}
  \item Report bugs at \url{https://github.com/Bioconductor/Bioc.gff/issues}
}

}
\author{
\strong{Maintainer}: Bioconductor Package Maintainer \email{maintainer@bioconductor.org}

Authors:
\itemize{
  \item Michael Lawrence
  \item Hervé Pagès
}

Other contributors:
\itemize{
  \item Marcel Ramos [contributor]
}

}
\keyword{internal}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GFFFile-class.R, R/utilities.R
\docType{class}
\name{GFFFile-class}
\alias{GFFFile-class}
\alias{class:GFFFile}
\alias{class:GFF1File}
\alias{class:GFF2File}
\alias{class:GFF3File}
\alias{class:GVFFile}
\alias{class:GTFFile}
\alias{GFF1File-class}
\alias{GFF2File-class}
\alias{GFF3File-class}
\alias{GVFFile-class}
\alias{GTFFile-class}
\alias{GFFFile}
\alias{GFF1File}
\alias{GFF2File}
\alias{GFF3File}
\alias{GVFFile}
\alias{GTFFile}
\alias{import,GFFFile,ANY,ANY-method}
\alias{import.gff}
\alias{import.gff1}
\alias{import.gff2}
\alias{import.gff3}
\alias{import.gff,ANY-method}
\alias{import.gff1,ANY-method}
\alias{import.gff2,ANY-method}
\alias{import.gff3,ANY-method}
\alias{export,ANY,GFFFile,ANY-method}
\alias{export,GenomicRanges,GFFFile,ANY-method}
\alias{export,GenomicRangesList,GFFFile,ANY-method}
\alias{export,GRangesList,GFFFile,ANY-method}
\alias{export,GRangesList,GTFFile,ANY-method}
\alias{export.gff}
\alias{export.gff,ANY-method}
\alias{export.gff1}
\alias{export.gff1,ANY-method}
\alias{export.gff2}
\alias{export.gff2,ANY-method}
\alias{export.gff3}
\alias{export.gff3,ANY-method}
\alias{genome,GFFFile-method}
\alias{export,CompressedGRangesList,GFFFile,ANY-method}
\alias{export,SimpleGRangesList,GFFFile,ANY-method}
\title{GFFFile objects}
\usage{
GFFFile(resource, version = c("", "1", "2", "3"))

export.gff(object, con, ...)

\S4method{export.gff}{ANY}(object, con, ...)

\S4method{export}{ANY,GFFFile,ANY}(object, con, format, ...)

\S4method{export}{CompressedGRangesList,GFFFile,ANY}(object, con, format, ...)

\S4method{export}{GenomicRanges,GFFFile,ANY}(
  object,
  con,
  format,
  version = c("1", "2", "3"),
  source = "Bioc.gff",
  append = FALSE,
  index = FALSE
)

\S4method{export}{SimpleGRangesList,GFFFile,ANY}(object, con, format, ...)

export.gff1(object, con, ...)

\S4method{export.gff1}{ANY}(object, con, ...)

export.gff2(object, con, ...)

\S4method{export.gff2}{ANY}(object, con, ...)

export.gff3(object, con, ...)

\S4method{export.gff3}{ANY}(object, con, ...)

\S4method{import}{GFFFile,ANY,ANY}(
  con,
  format,
  text,
  version = c("", "1", "2", "3"),
  genome = NA,
  colnames = NULL,
  which = NULL,
  feature.type = NULL,
  sequenceRegionsAsSeqinfo = FALSE
)

import.gff1(con, ...)

\S4method{import.gff1}{ANY}(con, ...)

import.gff2(con, ...)

\S4method{import.gff2}{ANY}(con, ...)

import.gff3(con, ...)

\S4method{import.gff3}{ANY}(con, ...)

\S4method{genome}{GFFFile}(x)
}
\arguments{
\item{resource}{\code{character(1)} or \code{connection} A low-level resource typically
a path, URL, or connection.}

\item{version}{If the format is given as "gff", i.e., it does not specify a
version, then this should indicate the GFF version as one of \dQuote{} (for
import only, from the \code{gff-version} directive in the file or "1" if none),
"1", "2" or "3".}

\item{object}{The object to export, should be a \code{GRanges} or something
coercible to a \code{GRanges}. If the object has a method for \code{asGFF}, it is
called prior to coercion. This makes it possible to export a \code{GRangesList}
or \code{TxDb} in a way that preserves the hierarchical structure. For exporting
multiple tracks, in the UCSC track line metaformat, pass a
\code{GenomicRangesList}, or something coercible to one.}

\item{con}{A path, URL, connection or \code{GFFFile} object. For the functions
ending in \code{.gff}, \code{.gff1}, etc, the file format is indicated by the
function name. For the base \code{export} and \code{import} functions, the format
must be indicated another way. If \code{con} is a path, URL or connection,
either the file extension or the \code{format} argument needs to be one of
"gff", "gff1" "gff2", "gff3", "gvf", or "gtf". Compressed files ("gz",
"bz2" and "xz") are handled transparently.}

\item{...}{Arguments to pass down to methods to other methods. For import,
the flow eventually reaches the \code{GFFFile} method on \code{import}. When
\code{trackLine} is \code{TRUE} or the target format is BED15, the arguments are
passed through \code{export.ucsc}, so track line parameters are supported.}

\item{format}{If not missing, should be one of "gff", "gff1" "gff2", "gff3",
"gvf", or "gtf".}

\item{source}{The value for the source column in GFF. This is typically the
name of the package or algorithm that generated the feature.}

\item{append}{If \code{TRUE}, and \code{con} points to a file path, the data is
appended to the file. Obviously, if \code{con} is a connection, the data is
always appended.}

\item{index}{If \code{TRUE}, automatically compress and index the output file with
bgzf and tabix. Note that tabix indexing will sort the data by chromosome
and start. Tabix supports a single track in a file.}

\item{text}{If \code{con} is missing, a character vector to use as the input.}

\item{genome}{The identifier of a genome, or a \code{Seqinfo}, or \code{NA} if unknown.
Typically, this is a UCSC identifier like "hg19". An attempt will be made
to derive the \code{Seqinfo} on the return value using either an installed
BSgenome package or UCSC, if network access is available.}

\item{colnames}{A character vector naming the columns to parse. These should
name either fixed fields, like \code{source} or \code{type}, or, for GFF2 and GFF3,
any attribute.}

\item{which}{A \code{GRanges} or other range-based object supported by
\code{\link[IRanges]{findOverlaps}}. Only the intervals in the file
overlapping the given ranges are returned. This is much more efficient when
the file is indexed with the tabix utility.}

\item{feature.type}{\code{NULL} (the default) or a character vector of valid
feature types. If not \code{NULL}, then only the features of the specified
type(s) are imported.}

\item{sequenceRegionsAsSeqinfo}{If \code{TRUE}, attempt to infer the \code{Seqinfo}
(\code{seqlevels} and \code{seqlengths}) from the \dQuote{##sequence-region}
directives as specified by GFF3.}

\item{x}{A \code{GFFFile} object.}
}
\value{
A \code{GRanges} with the metadata columns described in the details.
}
\description{
These functions support the import and export of the GFF format,
of which there are three versions and several flavors.
}
\details{
The Generic Feature Format (GFF) format is a tab-separated table of
intervals. There are three different versions of GFF, and they all have the
same number of columns. In GFF1, the last column is a grouping factor,
whereas in the later versions the last column holds application-specific
attributes, with some conventions defined for those commonly used. This
attribute support facilitates specifying extensions to the format. These
include GTF (Gene Transfer Format, an extension of GFF2) and GVF (Genome
Variation Format, an extension of GFF3).  The \code{Bioc.gff} package recognizes
the "gtf" and "gvf" extensions and parses the extra attributes
into columns of the result; however, it does not perform any
extension-specific processing. Both GFF1 and GFF2 have been proclaimed
obsolete; however, the UCSC Genome Browser only supports GFF1 (and GTF), and
GFF2 is still in broad use.

GFF is distinguished from the simpler BED format by its flexible attribute
support and its hierarchical structure, as specified by the \code{group}
column in GFF1 (only one level of grouping) and the \code{Parent} attribute
in GFF3. GFF2 does not specify a convention for representing hierarchies,
although its GTF extension provides this for gene structures. The
combination of support for hierarchical data and arbitrary descriptive
attributes makes GFF(3) the preferred format for representing gene models.

Although GFF features a \code{score} column, large quantitative data belong
in a format like \code{BigWig} and alignments from
high-throughput experiments belong in \link[Rsamtools:BamFile]{BAM}. For
variants, the VCF format (supported by the VariantAnnotation package) seems
to be more widely adopted than the GVF extension.

A note on the UCSC track line metaformat: track lines are a means for
passing hints to visualization tools like the UCSC Genome Browser and the
Integrated Genome Browser (IGB), and they allow multiple tracks to be
concatenated in the same file. Since GFF is not a UCSC format, it is not
common to annotate GFF data with track lines, but \code{Bioc.gff} still
supports it. To export or import GFF data in the track line format, call
\code{export.ucsc} or \code{import.ucsc}.

The following is the mapping of GFF elements to a \code{GRanges} object.  NA
values are allowed only where indicated.  These appear as a "." in
the file. GFF requires that all columns are included, so \code{export}
generates defaults for missing columns.

\describe{
\item{seqid, start, end}{the \code{ranges} component.}
\item{source}{character vector in the \code{source} column; defaults to
"Bioc.gff" on export.}
\item{type}{character vector in the \code{type} column; defaults to
"sequence_feature" in the output, i.e., SO:0000110.}
\item{score}{numeric vector (NA's allowed) in the \code{score} column,
accessible via the \code{score} accessor; defaults to \code{NA} upon export.}
\item{strand}{strand factor (NA's allowed) in the \code{strand} column,
accessible via the \code{strand} accessor; defaults to \code{NA} upon export.}
\item{phase}{integer vector, either 0, 1 or 2 (NA's allowed); defaults to
\code{NA} upon export.}
\item{group}{a factor (GFF1 only); defaults to the \code{seqid} (e.g.,
chromosome) on export.}
}

In GFF versions 2 and 3, attributes map to arbitrary columns in the result.
In GFF3, some attributes (\code{Parent}, \code{Alias}, \code{Note}, \code{DBxref} and
\code{Ontology_term}) can have multiple, comma-separated values; these columns are
thus always \code{CharacterList} objects.
}
\section{Functions}{
\itemize{
\item \code{export.gff()}: 

\item \code{export.gff(ANY)}: 

\item \code{export(object = ANY, con = GFFFile, format = ANY)}: 

\item \code{export(object = CompressedGRangesList, con = GFFFile, format = ANY)}: 

\item \code{export(object = GenomicRanges, con = GFFFile, format = ANY)}: 

\item \code{export(object = SimpleGRangesList, con = GFFFile, format = ANY)}: 

\item \code{export.gff1()}: 

\item \code{export.gff1(ANY)}: 

\item \code{export.gff2()}: 

\item \code{export.gff2(ANY)}: 

\item \code{export.gff3()}: 

\item \code{export.gff3(ANY)}: 

\item \code{import(con = GFFFile, format = ANY, text = ANY)}: 

\item \code{import.gff1()}: 

\item \code{import.gff1(ANY)}: 

\item \code{import.gff2()}: 

\item \code{import.gff2(ANY)}: 

\item \code{import.gff3()}: 

\item \code{import.gff3(ANY)}: 

\item \code{genome(GFFFile)}: Gets the genome identifier from the "genome-build"
header directive.

}}
\section{GFFFile objects}{
 The \code{GFFFile} class extends
\code{\link[BiocIO:BiocFile-class]{BiocFile}} and is a formal
representation of a resource in the GFF format.  To cast a path, URL or
connection to a \code{GFFFile}, pass it to the \code{GFFFile} constructor. The
\code{GFF1File}, \code{GFF2File}, \code{GFF3File}, \code{GVFFile} and \code{GTFFile} classes all
extend \code{GFFFile} and indicate a particular version of the format.
}

\examples{

test_gff3 <- system.file(
    "extdata", "genes.gff3", package = "Bioc.gff", mustWork = TRUE
)

## basic import
test <- import(test_gff3)
test

## import.gff functions
import.gff(test_gff3)
import.gff3(test_gff3)

## GFFFile derivatives
test_gff_file <- GFF3File(test_gff3)
import(test_gff_file)
test_gff_file <- GFFFile(test_gff3)
import(test_gff_file)
test_gff_file <- GFFFile(test_gff3, version = "3")
import(test_gff_file)

## from connection
test_gff_con <- file(test_gff3)
test <- import(test_gff_con, format = "gff")

## various arguments
import(test_gff3, genome = "hg19")
import(test_gff3, colnames = character())
import(test_gff3, colnames = c("type", "geneName"))

## 'which'
library(GenomicRanges)
which <- GRanges("chr10:90000-93000")
import(test_gff3, which = which)

## 'append'
test_gff3_out <- file.path(tempdir(), "genes.gff3")

export(test[seqnames(test) == "chr10"], test_gff3_out)
export(test[seqnames(test) == "chr12"], test_gff3_out, append = TRUE)
import(test_gff3_out)

## 'index'
export(test, test_gff3_out, index = TRUE)
test_bed_gz <- paste(test_gff3_out, ".bgz", sep = "")
import(test_bed_gz, which = which)

## cleanup
file.remove(
    test_gff3_out, test_bed_gz, paste(test_bed_gz, "tbi", sep = ".")
)

}
\references{
\itemize{
\item GFF1, GFF2: \url{http://www.sanger.ac.uk/resources/software/gff/spec.html}
\item GFF3: \url{http://www.sequenceontology.org/gff3.shtml}
\item GVF: \url{http://www.sequenceontology.org/resources/gvf.html}
\item GTF: \url{http://mblab.wustl.edu/GTF22.html}
}
}
\author{
Michael Lawrence
}
\keyword{classes}
\keyword{methods}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/readGFF.R
\name{readGFF}
\alias{readGFF}
\alias{GFFcolnames}
\title{Reads a file in GFF format}
\usage{
GFFcolnames(GFF1 = FALSE)

readGFF(
  filepath,
  version = 0,
  columns = NULL,
  tags = NULL,
  filter = NULL,
  nrows = -1,
  raw_data = FALSE
)
}
\arguments{
\item{GFF1}{\code{logical(1)} Use "group" instead of "attributes" for the 9th
column name. Default is \code{FALSE}.}

\item{filepath}{A single string containing the path or URL to the file to
read. Alternatively can be a connection.}

\item{version}{\code{readGFF} should do a pretty descent job at detecting
the GFF version. Use this argument \emph{only} if it doesn't or if you want
to force it to parse and import the file as if its 9-th column was in a
different format than what it really is (e.g. specify \code{version=1} on a
GTF or GFF3 file to interpret its 9-th column as the \code{"group"} column
of a GFF1 file). Supported versions are 1, 2, and 3.}

\item{columns}{The standard GFF columns to load. All of them are loaded by
default.}

\item{tags}{The tags to load. All of them are loaded by default.}

\item{filter}{\verb{named list()} Specify to load only desired features,
e.g., \code{list(type = c("gene", "mRNA"), seqid = "chr10")}.}

\item{nrows}{\code{-1} or the maximum number of rows to read in (after
filtering).}

\item{raw_data}{\code{logical(1)} If TRUE, numeric columns (e.g. "start" or
"score") are loaded as character vectors and as-is i.e. how they are found
in the file.}
}
\value{
A \code{DataFrame} with columns corresponding to those in the GFF.
}
\description{
Reads a file in GFF format and creates a data frame or
\code{\link[S4Vectors:DataFrame-class]{S4Vectors::DataFrame()}} object from it. This is a lower-level function
that should not be called by the end user. Users are recommended to use
the \code{import()} function on the \code{GFFFile} or file path.
}
\examples{

## Standard GFF columns.
GFFcolnames()
GFFcolnames(GFF1=TRUE)  # "group" instead of "attributes"

test_gff3 <- system.file(
    "extdata", "genes.gff3", package="Bioc.gff", mustWork=TRUE
)

## Load everything.
df0 <- readGFF(test_gff3)
head(df0)

## Load some tags only (in addition to the standard GFF columns).
my_tags <- c("ID", "Parent", "Name", "Dbxref", "geneID")
df1 <- readGFF(test_gff3, tags=my_tags)
head(df1)

## Load no tags (in that case, the "attributes" standard column
## is loaded).
df2 <- readGFF(test_gff3, tags=character(0))
head(df2)

## Load some standard GFF columns only (in addition to all tags).
my_columns <- c("seqid", "start", "end", "strand", "type")
df3 <- readGFF(test_gff3, columns=my_columns)
df3
table(df3$seqid, df3$type)

library(GenomicRanges)
makeGRangesFromDataFrame(df3, keep.extra.columns=TRUE)

## Combine use of 'columns' and 'tags' arguments.
readGFF(test_gff3, columns=my_columns, tags=c("ID", "Parent", "Name"))
readGFF(test_gff3, columns=my_columns, tags=character(0))

## Use the 'filter' argument to load only features of type "gene"
## or "mRNA" located on chr10.
my_filter <- list(type=c("gene", "mRNA"), seqid="chr10")
readGFF(test_gff3, filter=my_filter)
readGFF(test_gff3, columns=my_columns, tags=character(0), filter=my_filter)

}
\seealso{
\itemize{
\item \link[=GFFFile-class]{import} for importing a GFF file as a
\code{\link[GenomicRanges:GRanges-class]{GenomicRanges::GRanges()}} object.
\item \code{\link[GenomicRanges:makeGRangesFromDataFrame]{GenomicRanges::makeGRangesFromDataFrame()}} in the
\pkg{GenomicRanges} package for making a \code{\link[GenomicRanges:GRanges-class]{GenomicRanges::GRanges()}}
object from a \code{data.frame} or \code{\link[S4Vectors:DataFrame-class]{S4Vectors::DataFrame()}} object.
\item \code{\link[txdbmaker:makeTxDbFromGFF]{txdbmaker::makeTxDbFromGFF()}} in the \pkg{txdbmaker}
package for importing a GFF file as a \link[GenomicFeatures:TxDb-class]{TxDb}
object.
\item The \code{\link[S4Vectors:DataFrame-class]{S4Vectors::DataFrame()}} class in the \pkg{S4Vectors} package.
}
}
\author{
H. Pagès
}
\keyword{manip}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/GFF-coercion.R
\name{asGFF}
\alias{asGFF}
\alias{asGFF,GRangesList-method}
\title{Coerce to GFF structure}
\usage{
asGFF(x, ...)

\S4method{asGFF}{GRangesList}(x, parentType = "mRNA", childType = "exon")
}
\arguments{
\item{x}{Generally, a tabular object to structure as GFF(3)}

\item{\dots}{Arguments to pass to methods}

\item{parentType}{The value to store in the \code{type} column for the
top-level (e.g., transcript) ranges.}

\item{childType}{The value to store in the \code{type} column for the child
(e.g., exon) ranges.}
}
\value{
For the \code{GRangesList} method: A \code{GRanges}, with the columns: \code{ID}
(unique identifier), \code{Name} (from \code{names(x)}, and the names on each
element of \code{x}, if any), \code{type} (as given by \code{parentType} and \code{childType}),
and \code{Parent} (to relate each child range to its parent at the top-level).
}
\description{
Coerce the structure of an object to one following GFF-like
conventions, i.e., using the \code{Parent} GFF3 attribute to encode the
hierarchical structure. This object is then suitable for export as GFF3.
}
\section{Methods (by class)}{
\itemize{
\item \code{asGFF(GRangesList)}: Coerce to GFF GRanges structure

}}
\examples{
library(TxDb.Hsapiens.UCSC.hg19.knownGene)
library(GenomicFeatures)
exons <- exonsBy(TxDb.Hsapiens.UCSC.hg19.knownGene)
mcols(asGFF(exons))
}
\author{
Michael Lawrence
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/metadataFromNCBI.R
\name{metadataFromNCBI}
\alias{metadataFromNCBI}
\alias{isNCBISpeciesURL}
\alias{parseOrganismFromNCBI}
\alias{parseTaxonomyIDFromNCBI}
\title{Obtain metadata from NCBI}
\usage{
isNCBISpeciesURL(url)

metadataFromNCBI(url)

parseOrganismFromNCBI(html)

parseTaxonomyIDFromNCBI(html, url)
}
\arguments{
\item{url}{A URL to the NCBI Taxonomy Browser, typically obtained from a
GFF file with the \verb{## species} line.}
}
\value{
\itemize{
\item metadataFromNCBI: A \code{list} with two elements: \verb{Taxonomy ID} and
\code{Organism}.
\item parseOrganismFromNCBI: A \code{character} with the Organism name.
\item isNCBISpeciesURL: A \code{logical} indicating if the URL is from the NCBI
Taxonomy Browser.
\item parseTaxonomyIDFromNCBI: A \code{character} with the Taxonomy ID.
}
}
\description{
These helper functions obtain both the Taxonomy ID and the Organism name from
the NCBI Taxonomy Browser. They are a modern re-write of the old functions in
\code{rtracklayer}. They use \code{httr2} and \code{rvest} to parse the HTML content.
}
\examples{
\donttest{
  isNCBISpeciesURL(.NCBI_TAX_URL)

  metadataFromNCBI(
      paste0(.NCBI_TAX_URL, "?mode=Info&id=9606")
  )
  metadataFromNCBI(
      paste0(.NCBI_TAX_URL, "?id=3702")
  )
  metadataFromNCBI(
      paste0(.NCBI_TAX_URL, "?name=drosophila+melanogaster")
  )
  metadataFromNCBI(
      paste0(.NCBI_TAX_URL, "?name=drosophila+miranda")
  )
}
}
\keyword{internal}
